DCL.EXE
! DCL Patches for implementing PUSH and POP commands a la TWENEX
! Two components to this mod, one to write the context save file, and one
! to restore it within the subprocess.
!
!  Created by:
!	Gary L. Grebus
!	Battelle Memorial Institute
!	Columbus, Ohio
!
!  1.00 - 7-Sep-1981
!	Initial version for VMS 2.3.  Permanent merge code commented out
!	but left here for documentation purposes.  
!
! Patch to convert the DCL EOD command into an P1 space image merge of 
! BAT$SYSTEM:DCLHOOK.EXE
EX/INS 4DB   ! $EOD code
REPLACE/INS 4DB
'BSBW 07CA'  ! Old instruction
EXIT
'PUSHR #3FD'		! Save registers we use
'MOVZWL #400,-(SP)'	! End VA for blueprint P0 VA range
'MOVZWL #200,-(SP)'	! Start VA for that range
'MOVL SP,R4'		! Addr of input VA range
'CLRQ -(SP)'		! Space for return VA range
'MOVL SP,R5'		! Address of return range buffer
'CLRQ -(SP)'		! Zero ident
'MOVL SP,R6'		! Address of ident quadword
'SUBL2 #200,SP'		! Allocate image header buffer
'MOVL SP,R7'
'PUSHAL W^0dd48'	! Desc for FILNAM1
'PUSHL	#7'
'MOVL	SP,R8'
'PUSHAL W^0dd50'	! Desc for DFLTNAM1
'PUSHL	#0F'
'MOVL	SP,R9'
'PUSHAQ (R6)'		! Ident param
'PUSHAQ (R5)'		! Return address range
'PUSHAQ (R4)'		! Blueprint for P0 range
'PUSHL #30'		! Flags IAC$M_MERGE!IAC$M_EXPREG
'PUSHAB (R7)'		! Image header buffer
'PUSHAQ (R9)'		! Desc for default file name
'PUSHAQ (R8)'		! Desc for image file name
'CALLS #7,@#80000190'	! Call SYS$IMGACT
'BLBC R0,IMGACT_ERR'	! Branch if error
'MOVQ (R5),R2'		! R2=start R3=end of range
'SUBL2 R2,R3'		! Get # of bytes mapped
'MOVL @#7FFEFE88,R0'	! Get PHD address (CTL$GL_PHD)
'ADDL3 #1FF,B^30(R0),B^4(R4)'	! Get start VA in P1 space
'SUBL3 R3,B^4(R4),(R4)'	! Get start VA in P1 space
'PUSHL #0'	! Delete P0 range mapped by $IMGACT
'PUSHL #0'
'PUSHAQ (R5)'
'CALLS #3,@#80000110' ! Call SYS$DELTVA
'BLBC R0,d100'	
'PUSHAQ (R6)'
'PUSHAQ (R5)'
'PUSHAQ (R4)'
'PUSHL #10'
'PUSHAB (R7)'
'PUSHAQ (R9)'
'PUSHAQ (R8)'
'CALLS #7,@#80000190'	! Call SYS$IMGACT
'BLBC R0,IMGACT_ERR'	! Branch if error
! Following code not needed now since there is no need to make the
! merged image stay past next image reset.
!'PUSHL (R5)'		! Get new base for control region
!'PUSHL #1'		! One arg for routine
!'MOVL SP,R4'		! Get addr of arg list
!'PUSHAL (R4)'		! Parm list address
!'PUSHAL W^SET_BASE'	! Routine address
!'CALLS #2,@#80000090'	! $CMKRNL
!'ADDL2 #8,SP'		! Clean args off the stacK
'CALLS #0,@B^0(R5)'	! Call the image we mapped
'd100: ADDL2 #228,SP'	! Clean VA ranges off and buffer off stack
'POPR #3FD'		! Restore registers
'BRW 11E6'		! Branch to CONTINUE code in DCL
'IMGACT_ERR: ADDL3 #1,(R5),R1' ! Anything mapped
'BEQL d100'		! Branch if nothing
'PUSHL R0'
'PUSHL #0'
'PUSHL #0'
'PUSHAQ (R5)'
'CALLS #3,@#80000110'	! Delete mapped range
'MOVL (SP)+,R0'		! Restore original error
'BRB d100'
!'SET_BASE: HALT'	! Entry mask
!'HALT'
!'MOVL B^4(AP),@#7FFEFE7C' !Set new control region base
!'MOVZBL #1,R0'		! Set status code
!'RET'
EXIT
!
! Patch for hook called whenever DCL is run in a subprocess.  Does a P0 space
! image merge of BAT$SYSTEM:FLOGHOOK.EXE
DEFINE DCL$STARTUP=17
EX/INS DCL$STARTUP+54	! Examine first instruction to zap
REPLACE/INS .
'CALLS #03,@#800002A0'  
'BRW 85'
EXIT
'CALLS #03,@#800002A0'
'PUSHR #3FD'		! Save our registers
'MOVZWL #400,-(SP)'	! End VA for merge range
'MOVZWL #200,-(SP)'	! Start VA for that range
'MOVL SP,R4'		! Addr of input addr range
'CLRQ -(SP)'		! Space for returned range
'MOVL SP,R5'		! Address of return range buffer
'CLRQ -(SP)'		! No ident
'MOVL	SP,R6'		! Address of ident quadword
'SUBL2	#200,SP'	! Allocate image header buffer
'MOVL SP,R7'
'PUSHAL W^0DD60'	! Desc for FILNAM2
'PUSHL #8'
'MOVL SP,R8'
'PUSHAL W^0DD50'	! Desc for DFLTNAM
'PUSHL #0F'
'MOVL SP,R9'
'PUSHAQ (R6)'		! Ident param
'PUSHAQ (R5)'		! Return address range
'PUSHAQ (R4)'		! Blueprint for P0 range
'PUSHL #30'		! Flags for IAC$M_MERGE!IAC$M_EXPREG
'PUSHAB (R7)'		! Image header buffer
'PUSHAQ (R9)'		! Desc for default file name
'PUSHAQ (R8)'		! Desc for image file name
'CALLS #7,@#80000190'	! Call SYS$IMAGACT
'BLBC R0,D10'		! Branch if error
'CALLS #0,@B^0(R5)'	! Call the image we mapped
'D10: ADDL2 #228,SP'		! Clean VA ranges and buffer off stack
'POPR #3FD'		! Restore registers
'BRW 085'		! Continue interrupted code
EXIT
!
!  Text of file specs for images to be merged
DEFINE FILNAM1 = .+4
DEPOSIT/ASCII FILNAM1
'DCLH'
'OOK '
EXIT
DEFINE DFLTNAM1 = .+4
DEPOSIT/ASCII DFLTNAM1
'BAT$'
'SYST'
'EM:.'
'EXE '
EXIT
DEFINE FILNAM2 = .+4
DEPOSIT/ASCII FILNAM2
'FLOG'
'HOOK'
EXIT
UPDATE
EXIT
