C
C	CLI.INC
C
C	THIS FILE DEFINES INTERFACE TO DCL CLI ROUTINES.
C

C
C	ACTUAL CLI REQUESTS ARE DEFINED IN A MACRO ROUTINE (WHICH
C	CONSISTS OF CLI MACROS). THE ADDRESS OF EACH REQUEST IS
C	RECORDED IN AN ARRAY WHICH FORTRAN ROUTINES REFERENCE
C	WHEN A CLI CALL BACK IS NECESSARY. THE FOLLOWING PARAM-
C	ETER STATEMENTS DEFINE OFFSETS (LONGWORD) WITHIH THIS
C	LABELED COMMON.
C


	PARAMETER INITIALIZE_PARSE	= 0	! INITIALIZES CLI PARSE
	PARAMETER PARSE_COMMAND		= 1	! FETCHES COMMAND LINE
	PARAMETER PARSE_COMMAND_QUALIFIERS = 2  ! PARSES COMMAND QUALIFIERS
	PARAMETER GET_INPUT_FILE_NAME	= 3	! RETRIEVES NEXT INPUT FILE
	PARAMETER END_INPUT_FILE_NAME	= 4	! ENDS PROCESSING CURRENT INPUT FILE
	PARAMETER GET_OUTPUT_FILE_NAME	= 5	! GETS OUTPUT FILE SPEC
	PARAMETER END_OUTPUT_FILE_NAME	= 6	! ENDS PROCESSING OUTPUT FILESPEC
	PARAMETER GET_TAB_STOP_VALUE	= 7	! RETRIEVES NEXT TAB STOP

C
C	REQUEST ARRAY CONTAINS ADDRESSES OF VARIOUS REQUEST BLOCKS.
C	THESE ADDRESSES ARE REFERENCED BY THE PREVIOUS PARAMETER
C	DEFINITIONS.
C

	INTEGER*4 REQUEST(0:GET_TAB_STOP_VALUE)

	COMMON /CLI_REQUEST/ REQUEST

C
C	THE NEXT PARAMETER DEFINES SIZE OF CLI WORK AREA AND
C	DEFINES OFFSETS INTO CLI REQUEST BLOCKS. THESE
C	DEFINITIONS COME FROM (SYS$LIBRARY:LIB.MLB/EXT=$CLIDEF).
C
	PARAMETER CLI$K_WORKAREA	= '80'X
	PARAMETER CLI$W_RQSIZE		= '08'X
	PARAMETER CLI$A_RQADDR		= '0C'X
	PARAMETER CLI$Q_RQDESC		= CLI$W_RQSIZE
	PARAMETER CLI$_BADTEXT		= '381B0'X
	PARAMETER CLI$L_RQVALU		= '0C'X
	PARAMETER CLI$B_RQSTAT		= '03'X
	PARAMETER CLI$V_MOREVALS	= '00'X

C
C	DEFINE WORK AREAS NEEDED BY CLI INTERFACE ROUTINES.
C

	INTEGER*4 WORK_AREA(0:CLI$K_WORKAREA/4)
	INTEGER*4 CONTEXT_AREA(0:2)

	COMMON /CLI_DATA/ CONTEXT_AREA, WORK_AREA

