	SUBROUTINE BUILD_RMS_DATA_STRUCTURES
	IMPLICIT INTEGER (A-Z)
C++
C
C FUNCTION:
C
C	THIS MODULE BUILDS RMS DATA STRUCTURES REQUIRED BY DCL
C	LIST COMMAND.
C
C INPUTS:
C
C	NONE
C
C OUTPUTS:
C
C	THE INPUT AND OUTPUT FAB, RAB, NAM ARE INITIALIZED.
C
C--

	INCLUDE 'PARAM.INC'
	INCLUDE 'RMSDATA.INC'
	INCLUDE 'BUFFER.INC'
	INCLUDE 'LIBRARY:RMS.INC/NOLIST'

	CHARACTER C_INPUT_FAB*(FAB$C_BLN),
	1         C_INPUT_RAB*(RAB$C_BLN),
	2         C_INPUT_NAM*(NAM$C_BLN)

	CHARACTER C_OUTPUT_FAB*(FAB$C_BLN),
	1         C_OUTPUT_RAB*(RAB$C_BLN),
	2         C_OUTPUT_NAM*(NAM$C_BLN)

	EQUIVALENCE (INPUT_FAB,C_INPUT_FAB(1:1)),
	1           (INPUT_RAB,C_INPUT_RAB(1:1)),
	2           (INPUT_NAM,C_INPUT_NAM(1:1))

	EQUIVALENCE (OUTPUT_FAB,C_OUTPUT_FAB(1:1)),
	1           (OUTPUT_RAB,C_OUTPUT_RAB(1:1)),
	2           (OUTPUT_NAM,C_OUTPUT_NAM(1:1))


	INTEGER*4 LINE_NUMBER

	CALL RMS$FAB(FAB$D(C_INPUT_FAB),
	1            NAM$D(C_INPUT_NAM),
	2            'FOP=SQO')

	CALL RMS$RAB(RAB$D(C_INPUT_RAB),
	1            FAB$D(C_INPUT_FAB),
	2            RHB$R(LINE_NUMBER),
	3            UBF$D(INPUT_BUFFER),
	4            USZ$R(INPUT_BUFFER_SIZE),
	5            'MBC=4',
	6            'MBF=2',
	7            'ROP=<LOA,RAH>')

	CALL RMS$NAM(NAM$D(C_INPUT_NAM),
	1            RS$D(INPUT_RS),
	2            ES$D(INPUT_ES))

	CALL RMS$FAB(FAB$D(C_OUTPUT_FAB),
	1            NAM$D(C_OUTPUT_NAM),
	2            'RAT=CR',
	3            'RFM=VAR',
	4            'FOP=SQO')

	CALL RMS$RAB(RAB$D(C_OUTPUT_RAB),
	1            FAB$D(C_OUTPUT_FAB),
	2            UBF$D(OUTPUT_BUFFER),
	3            USZ$R(OUTPUT_BUFFER_SIZE),
	4            'MBC=4',
	5            'MBF=2',
	6            'ROP=WBH')

	CALL RMS$NAM(NAM$D(C_OUTPUT_NAM),
	1            RS$D(OUTPUT_RS),
	2            ES$D(OUTPUT_ES))

	RETURN
	END

