	SUBROUTINE WRITE_LINE
	IMPLICIT INTEGER*4 (A-Z)
C++
C
C FUNCTION:
C
C	THIS ROUTINE WRITES A LINE TO THE OUTPUT FILE. IF THE CURRENT
C	PAGE IS FULL, A NEW PAGE IS STARTED.
C
C INPUTS:
C
C	NONE
C
C IMPLICIT INPUTS:
C
C	OUTPUT_BUFFER		DATA TO BE WRITTEN OUT
C	LENGTH_OUTPUT_RECORD	SIZE OF RECORD TO BE WRITTEN
C	CURRENT_PAGE		CURRENT PAGE NO
C	CURRENT_LINE		LINES ON CURRENT PAGE
C
C OUTPUTS:
C
C	THE LINE AND HEADING (IF NECESSARY) IS WRITTEN TO THE OUTPUT
C	FILE.
C
C SIDE EFFECTS:
C
C	ANY ERROR WRITING TO THE OUTPUT FILE IS FATAL. THE ERROR
C	CONDITION IS SIGNALED, AND AN UNWIND TO THE MAIN ROUTINE
C	OCCURS.
C
C--

	INCLUDE 'PARAM.INC'
	INCLUDE 'RMSDATA.INC'
	INCLUDE 'LENGTH.INC'
	INCLUDE 'BUFFER.INC'
	INCLUDE 'STATUS.INC'

	EXTERNAL PUT_ERROR

C
C	CALCULATE NEW CURRENT LINE.
C

	CURRENT_LINE = CURRENT_LINE + 1

C
C	SEE IF PAGE SLEW REQUIRED.
C

	IF(CURRENT_LINE .GT. MAX_LINES_PER_PAGE) THEN

C
C	  SLEW IS REQUIRED. WRITE HEADING, ADJUST PAGE COUNT, AND
C	  RESET LINE COUNT.
C
	  CURRENT_LINE = 1
	  CURRENT_PAGE = CURRENT_PAGE + 1
	  CALL SYS$FAO('!5UL',
	1               ,
	2               HEADING_1(LENGTH_HEADING_1+1:),
	3               %VAL(CURRENT_PAGE))

	  CALL COPY(4,
	1           %LOC(HEADING_1),
	2           OUTPUT_RAB(RAB$L_RBF))

	  CALL COPY(2,
	1           LENGTH_HEADING_1+5,		! +5 TO INCLUDE LINE NO
	2           OUTPUT_RAB(RAB$W_RSZ))

	  CALL SYS$PUT(OUTPUT_RAB,PUT_ERROR,)

	  CALL COPY(4,
	1           %LOC(HEADING_2),
	2           OUTPUT_RAB(RAB$L_RBF))

	  CALL COPY(2,
	1           LENGTH_HEADING_2,
	2           OUTPUT_RAB(RAB$W_RSZ))

	  CALL SYS$PUT(OUTPUT_RAB,PUT_ERROR,)


	  END IF

C
C	IF ANY HEADING WAS NEEDED, IT HAS BEEN PRINTED. NOW WRITE OUTPUT
C	LINE.
C

	CALL COPY(4,
	1         %LOC(OUTPUT_BUFFER),
	2         OUTPUT_RAB(RAB$L_RBF))

	CALL COPY(2,
	1         LENGTH_OUTPUT_RECORD,
	2         OUTPUT_RAB(RAB$W_RSZ))

	CALL SYS$PUT(OUTPUT_RAB,PUT_ERROR,)

	RETURN
	END


