/*==================================================
 * Processor to Mp compilations
 *==================================================
 */
#include <stdio.h>
typedef char logical;
#define FALSE   0
#define TRUE    -1
#define NL      '\n'
#define EOS     '\0'
#define PI      3.1415926536

static FILE *cmds = 0;

main(argc,argv)
char *argv[];
{
	 logical verbose=FALSE,pass1=FALSE,nolink= FALSE ,keepa=FALSE;
         logical monkeys=FALSE,preponly=FALSE,build=FALSE;
	 logical keeptemp=FALSE,edit=FALSE,optom=FALSE,incl=FALSE;
	 char    *temp = "mpp.tmp", *source = "#", *builder  = "#";
         char    *p, gocmd[80],godesc[100],*index();
	 int oline;

         if (argc < 2)
           helpout();
         while (argv[1]) {
           stolower(argv[1]);
           if (argv[1][0] == '-')
             switch (argv[1][1]) {
             case '?':
               helpout();
               break;
             case 'a':
               keepa = TRUE;
               break;
             case 'b':
               build = TRUE;
               break;
             case 'c':
	       nolink = TRUE;
               break;
             case 'e':
               edit = TRUE;
               break;
             case 'p':
               preponly = TRUE;
               break;
             case 'o':
               optom = TRUE;
	       oline = atoi(&argv[1][2]);
               break;
	     case 'i':
	       incl = TRUE;
               break;
             case 'k':
               keeptemp = TRUE;
               break;
             case 't':
               nolink = FALSE;
               if (argc > 2) {
                 builder = argv[2];
                 argc--;
                 argv++;
               }
               break;
             case 'v':
               verbose = TRUE;
               break;
             case 'w':
               monkeys = TRUE;
               break;
             default:
               error("Unknown option: %c",argv[1][1]);
             }
           else source = argv[1];
           argc--;
           argv++;
         }
	 if (source[0] == '#')
           error("No source file ??!!");
         if ((p=index(source,'.')))
           *p = EOS;
	 sprintf(gocmd,"%s.mac",source);
	 if (edit == FALSE && access(gocmd,0) != 0)
           error("%s does not exist ??!!",gocmd);
         if (builder[0] == '#')
           builder = source;

         if ((cmds=fopen(temp,"write","r")) == NULL)
           exit(0);
         if(edit) {
           cmd("assign/user TT: sys$input");
	   cmd("e %s.mac",source);
         }
         cmd("on CONTROL_Y then goto interrupt");
         cmd("on ERROR then goto interrupt");
	 if (verbose && !incl)
	   _tell("pre",FALSE);
         if (preponly)
	   cmd("include <%s.mac >%s.tmp",source,source);
         else {
	   if(!incl)
                 {
	       cmd("include <%s.mac >%s.tmp",source,source);
		 }
               else
                 {
               cmd("pip %s.tmp/nv=%s.mac",source,source);
		 }
           if (verbose)
	     _tell("mp",FALSE);
	     cmd("mcr levydisk:[levy.mpvax]mp.exe %s.mpp=%s.tmp/nl/nb",
							 source,source);


	     if (!optom) {
               if (verbose)
                  _tell("mac",FALSE);
		cmd("macro %s.mpp",source);
             } else {
                  if (verbose)
		      _tell("opt",FALSE);
		  if (oline == 0) oline=50;
		cmd("mcr levydisk:[levy.mpvax]opt.exe -%c%d  <%s.mpp >=%s.opt",
						     'l',oline,source,source);
                  if (verbose)
                     _tell("mac",FALSE);
		cmd("macro %s.opt",source);
             }
             if (build)
               dobuilder(builder);
             if (! nolink) {
               if (verbose)
                 _tell("Link",FALSE);
               cmd("@%s.bld",builder);
             }

         }
         cmd("interrupt:");
         if (verbose)
           _tell("Clean",TRUE);
         cmd("pip %s;*/de/nm",temp);
	 if (! keepa)   {
	   cmd("pip %s.mpp;*/de/nm,%s.opt;*/de/nm",source,source);
	   if (!preponly) {
	      cmd("pip %s.tmp;*/de/nm",source);
	   }
	 }
         fclose(cmds);

         sprintf(gocmd,"@%s",temp);
         atodesc(gocmd,godesc);
         if (!keeptemp) {
           libdo(godesc);
           error("System execution error; tell a guru");
         } 
         else {
	   eprintf("Done, %s created\n",temp);
           exit(1);
         }
}

/*
 *==================================================
 *==================================================
 */
cmd(string)
char *string;
{
         putc('$',cmds);
         putc(' ',cmds);
	 fprintf(cmds,"%r",&string);
         putc(NL,cmds);
}

/*
 *==================================================
 *==================================================
 */
static _tell(message,nodots)
char *message;
{
         /*       if (nodots)            */
         cmd("write sys$output \"%s\"",message);
         /*       else    cmd("echo -n \"%s ...\"",message); */
}

/*
 *==================================================
 *==================================================
 */
dobuilder(name)
char *name;
{
         char buffer[40];
         FILE *bld;

         sprintf(buffer,"%s.bld",name);
         if (access(buffer,0) == 0)
           return;
         if ((bld=fopen(buffer,"w","r")) == NULL)
           error("Unable to construct build file: %s",buffer);
         fprintf(bld,"$ here := SYS$DISK:'F$DIRECTORY()'\n",bld);
         fprintf(bld,"$ link/exe=%s jplclib:cheader, -\n",name);
         fprintf(bld,"\t'here'%s, -\n",name);
         fprintf(bld,"\tjplclib:runtime/lib\n");
         fclose(bld);
}
/*
 *==================================================
 *==================================================
 */
helpout() {
	 eprintf("Usage: mm [-option] [-option] file\n");
         eprintf("   Option list:\n");
         eprintf("%ta   keep assembly file\n");
         eprintf("%tb   build a bld file on the way\n");
	 eprintf("%tc   compile only\n");
         eprintf("%te   edit source file first\n");
	 eprintf("%ti   don't do include pre processes or include pass\n");
         eprintf("%tk   keep generated commands in mpp.tmp and don't execute\n");
         eprintf("%tp   preprocessor only\n");
         eprintf("%tt   like c but use next arg as build file name\n");
         eprintf("%tv   verbose\n");

         exit(1);
}
error(arglist)
{
         eprintf("Error: %r",&arglist);
         eprintf("\n");
         exit(1);
}
static char *index(in,of) char in[]; 
char of;
{
         char str[5]; 
         int i;
         str[0] = of;
         str[1] = '\0';


         i = pos(in,str,1) - 1;
         if (i <  0) return 0;
         return &in[i];

}
