%{
#define short int
#define txt yytext

#define REturn(V) if(deb){eprintf("lx=%d,str=(%s)\n",V,yylval);} return(V);
#define Return(V) if(deb){eprintf("lx=%d,val=%c\n",V,yylval);} return(V);

#define debug

#ifndef debug
#define REturn(VVV) return(VVV)
#define Return(VVV) return(VVV)
#endif

#include "[levy.c]eric.h"
#include "ytab.h"


extern char string[], *str;
extern yylval;
extern istack[], istp;
extern ln;              /* line number */

int argc_ = 0;
char *argv_[20] = 0;
int deb = {0};


%}
D      ([0-9])
L      ([a-zA-Z'])
ALPHA   ({D}|{L}|['_$])
NUMBER  ({D}+)
LABEL   ({L}{ALPHA}*)
WHITE   ((" "|"\t")*)
WHITEP  ((" "|"\t")+)
DOT         (".")
Q       \"
LQ       ("`"|"'")
ESCAPENL (\\"n")
ESCAPETAB (\\"t")
%%
{WHITEP}        ;
"debug"          { deb = 1; }
"\\".*"\n"       {ln++; /* eat up the newline but count it */ }
"sqrt"           { yylval = txt[0]; Return( SQRT ); }
"length"         { yylval = txt[0]; Return( LENGTH ); }
"if"             { yylval = txt[0]; Return( _IF ); }
[=()+*/-]        { yylval = txt[0]; Return( yylval ); }
":="             { yylval = txt[0]; Return( COEQ ); }
":=="            { yylval = txt[0]; Return( COEQEQ ); }
"=="             { yylval = txt[0]; Return( EQ ); }
"while"          { yylval = txt[0]; Return( _WHILE ); }
"for"            { yylval = txt[0]; Return( _FOR ); }
"rof"            { yylval = txt[0]; Return( '}'  ); }
"||"             { yylval = txt[0]; Return( _OR ); }
"&&"             { yylval = txt[0]; Return( _AND ); }
"!="             { yylval = txt[0]; Return( NE ); }
"<="             { yylval = txt[0]; Return( LE ); }
">="             { yylval = txt[0]; Return( GE ); }
"++"             { yylval = txt[0]; Return( INCR ); }
"--"             { yylval = txt[0]; Return( DECR ); }
"return"         { yylval = txt[0]; Return( _RETURN ); }
"elseif"         { testlev("elseif"); yylval = txt[0]; Return( _ELSEIF ); }
"else"           {
		  testlev("else"); yylval = txt[0]; Return( _ELSE   );
			unput(' ');
			unput('n');
			unput('e');
			unput('h');
			unput('t');
		  }
"break"          { yylval = txt[0]; Return( _BREAK ); }
"eq"             { yylval = txt[0]; Return( EQS ); }
"do"             { yylval = txt[0]; Return( '{' ); }
"ne"             { yylval = txt[0]; Return( NEQS ); }
"le"             { yylval = txt[0]; Return( LES ); }
"ge"             { yylval = txt[0]; Return( GES ); }
"lt"             { yylval = txt[0]; Return( LTS ); }
"gt"             { yylval = txt[0]; Return( GTS ); }
"auto"           { yylval = txt[0]; Return( _AUTO ); }
"then"           { yylval = txt[0]; Return( _THEN ); }
"fi"             {
		/* eprintf("istp=%d,istack=%d\n",istp,istack[istp-3]); */
		   if (istack[istp-3] > 1 ) then
                       istack[istp-3]--;
			unput('i');
			unput('f');
			unput(';');
		   fi
		   yylval = 'f'; Return( _FI );
		 }
"quit"           { yylval = txt[0]; getout(); }
("%"[Xx])?{NUMBER}    {
		       yylval = str;
		       strcopy(str,txt); str = str + strlen(str) + 2;
			  if(str >= &string[800])
				{yyerror("string space exceeded"); getout();}
		       REturn( NUMBER );
		  }
"!"[^=].*$          ;
"$".*$             {
		       yylval = str;
			if (txt[1]=='$') then
			      strcopy(str,&txt[2]);
			els
			      strcopy(str,&txt[0]);
			fi
			str = str + strlen(str) + 2;
			if(str >= &string[800])
			     {yyerror("string space exceeded"); getout();}
		       REturn( DCL );
		  }
{LABEL}          {
		       yylval = str;
		       strcopy(str,txt); str = str + strlen(str) + 2;
			  if(str >= &string[800])
				{yyerror("string space exceeded"); getout();}
		       REturn( LETTER );
		  }
\"[^"]*          {
		   int shit;
		   if(yytext[yyleng-1]=='\\') then
                      yymore();
                   els
		       shit = input();
		       yylval = str;
		       strcp(str,&txt[1]); str = str + strlen(str) + 10;
			  if(str >= &string[800])
				{yyerror("string space exceeded"); getout();}
                       REturn( QSTR );
                   fi
                  }
.|"\n"           { yylval = txt[0]; Return( yylval ); }
%%

function strcp(b,a) char *a,*b;
{
  char c;
  for (;;) {
    c = *a++;
    if(c == '\0') then
	*b++ = c; break;
    elsif (c != '\\') then
	*b++ = c;
    els
	*b++ = '"';
    fi
  }
}
function testlev(a) char a[]; {

if (istp <=0) then
   eprintf("%s with no corresponding if",a);
   yyerror("");
fi
}

yywrap (){ getout();}
