      SUBROUTINE GETHELP(HELP_TOPIC)
C
C     SUBROUTINE TO OPEN AND READ A HELP LIBRARY
C
C     GETHELP CAN BE CALLED FROM A MAINLINE AS IN THE FOLLOWING
C     EXAMPLE:
C
C         ....
C         CHARACTER PARAMETER_REC*80
C         ....
C         ....
C         IF(PARAMETER_REC(1:4).EQ.'HELP') CALL GETHELP(PARAMETER_REC)
C         ....
C
C
C     WHEN GETHELP IS CALLED, IT BEGINS TO PARSE HELP_TOPIC AT THE
C     6TH BYTE, BECAUSE IT IS ASSUMED THAT BYTES 1-5
C     ARE "HELP ".
C
C
C     THE USER CAN REQUEST FROM ZERO TO FOUR KEYS:
C     HELP
C     HELP COPY
C     HELP SET PASSWORD
C     HELP SET PRINTER /FF
C     HELP BLACKBOOK BLONDES PRETTY /SINGLE
C
C
C     THE COMMAND PROCEDURE FILE MUST ASSIGN THE LIBRARY FILE
C     NAME TO HELP$LIB, AS IN THE FOLLOWING EXAMPLE:
C
C     $ASSIGN SYS$SYSTEM:PROPOSAL.HLB HELP$LIB
C
C
C     TO LINK A PROGRAM TO GETHELP, CONSTRUCT A LINKING
C     COMMAND PROCEDURE SIMILAR TO THE FOLLOWING:
C
C       $FOR [YOUR PROGRAM]
C       $LINK [YOUR PROGRAM],'UTILIB'/L,SYS$INPUT/OPTIONS
C       !
C       ! OPTIONS INPUT
C       SYS$LIBRARY:LBRSHR/SHARE          !INCLUDE LIBRARIAN
C
C
C
C
C     
C
C     WRITTEN OCTOBER, 1981
C     PROGRAMMER: MARILYN SHEAFFER
C
C
      IMPLICIT INTEGER (A-Z)
      COMMON /HLPCMN/ READ,CREATE,HELP,RMS
C
      CHARACTER HELP_TOPIC*80
      CHARACTER*20 KEY1,KEY2,KEY3,KEY4
C
C
C     CALL MACRO SUBROUTINE TO CREATE LIBRARY SYMBOLS
      CALL CRELBRSYM    
C
      CALL LBR$INI_CONTROL(INDEX1,READ,HELP)
C  
C
C     INITIALIZE KEYS
       KEY1 = ' '
       KEY2 = ' '
       KEY3 = ' '
       KEY4 = ' '
C
C
C
C
C     PARSE HELP_TOPIC INTO ITS KEYS
      I = 5 + INDEX(HELP_TOPIC(6:80),' ')
C
C     FILL KEY1
  300 IF(I.GT.6) THEN
         IM1 = I - 1
         KEY1 = HELP_TOPIC(6:IM1)
         ELSE
         KEY1 = 'HELP'
         ENDIF
C
C     FILL KEY2 IF NECESSARY
      IF(I.GT.6) THEN
      IP1 = I + 1
      I2 = I + INDEX(HELP_TOPIC(IP1:80),' ')
      I2M1 = I2 - 1
      IF(I2.GT.IP1) KEY2 = HELP_TOPIC(IP1:I2M1)
      ENDIF
C
C
C     FILL KEY3 IF NECESSARY
      IF(I2.GT.IP1) THEN
      I2P1 = I2 + 1
      I3 = I2 + INDEX(HELP_TOPIC(I2P1:80),' ')
      I3M1 = I3 - 1
      IF(I3.GT.I2P1) KEY3 = HELP_TOPIC(I2P1:I3M1)
      ENDIF
C
C
C     FILL KEY4 IF NECESSARY
      IF(I3.GT.I2P1) THEN
      I3P1 = I3 + 1
      I4 = I3 + INDEX(HELP_TOPIC(I3P1:80),' ')
      I4M1 = I4 - 1
      IF(I4.GT.I3P1) KEY4 = HELP_TOPIC(I3P1:I4M1)
      ENDIF
C
C
C
  500 CALL LBR$OPEN(INDEX1,%DESCR('HELP$LIB'))
C
C
C     LBR$GET_HELP APPEARS TO GET CONFUSED IF CALLED WITH
C     MORE KEYS THAN NEEDED
C
      IF(KEY4.NE.' ') GO TO 900
      IF(KEY3.NE.' ') GO TO 800
      IF(KEY2.NE.' ') GO TO 700
C
C
      CALL LBR$GET_HELP(INDEX1,80,,,KEY1)
      GO TO 1000
C
C
  700 CALL LBR$GET_HELP(INDEX1,80,,,KEY1,KEY2)
      GO TO 1000
C
C
  800 CALL LBR$GET_HELP(INDEX1,80,,,KEY1,KEY2,KEY3)
      GO TO 1000
C
C
  900 CALL LBR$GET_HELP(INDEX1,80,,,KEY1,KEY2,KEY3,KEY4)
C
C
 1000 CALL LBR$CLOSE(INDEX1)
C
      RETURN
      END
