C	BEGIN OF DMPHEAD.FOR INCLUDE FILE
C	CONTAINS EQUIVALENCES USED FOR DUMPER/BACKUP FORMAT HEADERS
C
C	FOR ALL HEADER BLOCKS:
C	G$TYPE -- THE TYPE OF HEADER
C	1=LABEL RECORD, 2=START OF SAVE SET, 3=END OF SAVE SET,
C	4=FILE RECORD, 5=UFD RECORD, 6=END OF VOLUME, 7=COMMENT
C	G$SEQ  -- A SEQUENCE NUMBER UNIQUE FOR THAT RECORD.
C	THIS NUMBER IS INCREMENTED FOR EACH RECORD WRITTEN.
C	G$RTNM -- THE RELATIVE TAPE NUMBER FOR THIS TAPE
C	WITHIN A SAVE SET.
C	G$FLAG -- VARIOUS BITS THAT DEPEND UPON THE TYPE OF
C	RECORD INVOLVED.  CURRENTLY, FOR ALL BUT DATA RECORDS,
C	THIS WORD IS ZERO.  FOR FILE DATA RECORDS, THE FOLLOWING
C	ASSIGNMENTS HAVE BEEN MADE.
C	 GF$EOF -- (DEC-10 BIT 0) THE FLAG SET IF THIS IS THE
C	 LAST TAPE BLOCK FOR THIS DISK FILE.  BOTH THIS AND
C	 GF$SOF CAN BE SET FOR SHORT ONE BLOCK FILES.
C	 GF$RPT -- (DEC-10 BIT 1) THIS FLAG IS SET IF THIS
C	 BLOCK REPEATS THE PREVIOUS ONE.  THIS IS USED IF A
C	 TAPE ERROR OCCURRED FOR THE PREVIOUS RECORD.
C	 GF$NCH -- (DEC-10 BIT 2) THIS IS SET IF A CHECKSUM
C	 FOR THE BLOCK HAS NOT BEEN COMPUTED.
C	 GF$SOF -- (DEC-10 BIT 3) THIS IS SET IF THIS IS THE
C	 FIRST TAPE BLOCK FOR A FILE.
C	G$CHK  -- CONTAINS THE CHECKSUM FOR THE TAPE RECORD
C	UNLESS GF$NCH IS SET.
C	G$SIZ  -- THE NUMBER OF FILE DATA WORDS IN THIS BLOCK.
C	G$LND  -- THE NUMBER OF WORDS TO SKIP BEFORE FILE DATA
C	BEGINS.
C
	INTEGER G$TYPE,G$SEQ,G$RTNM,G$FLAG,G$CHK,G$SIZ,G$LND
	PARAMETER (G$TYPE=1,G$SEQ=2,G$RTNM=3,G$FLAG=4,G$CHK=5,
	1 G$SIZ=6,G$LND=7)
	INTEGER GF$EOF,GF$RPT,GF$NCH,GF$SOF
	PARAMETER (GF$EOF=8,GF$RPT=4,GF$NCH=2,GF$SOF=1)
C
C	IN LABEL RECORDS (G$TYPE WORD IS 1):
C	L$RLNM -- SIXBIT WORD CONTAINING THE REEL NAME
C	L$DATE -- DATE/TIME OF THE LABELLING IN DEC-10
C	UNIVERSAL FORMAT (LEFT HALF IS NUMBER OF DAYS
C	SINCE 17-NOV-1859, AND RIGHT HALF IS FRACTIONS
C	OF A DAY)
C	L$DSTR -- DATE/TIME BEFORE WHICH THE TAPE CANNOT BE
C	SCRATCHED.  BEFORE THIS TIME, ONLY APPENDS CAN BE DONE
C	L$DEV  -- SIXBIT WORD DEFINING THE PHYSICAL DEVICE
C	NAME OF THE MAGTAPE DRIVE USED TO WRITE THE LABEL
C	L$FMT  -- A NUMBER INDICATING THE BACKUP FORMAT
C	L$BVER -- THE BACKUP VERSION USED TO WRITE THE LABEL
C
	INTEGER L$RLNM,L$DATE,L$DSTR,L$DEV,L$FMT,L$BVER
	PARAMETER (L$RLNM=13,L$DATE=14,L$DSTR=15,L$DEV=16,L$FMT=17,
	1 L$BVER=18)
C
C	FOR START AND END OF SAVE SET RECORDS:
C	S$SVER -- SYSTEM VERSION NUMBER
C	S$FMT  -- BACKUP FORMAT NUMBER
C	S$BVER -- BACKUP VERSION NUMBER
C	S$DATE -- DATE/TIME OF WRITING THE DATA IN UNIVERSAL
C	TIME FORMAT (SEE L$DATE DESCRIPTION)
C	S$DEV  -- PHYSICAL DEVICE NAME OF THE MAGTAPE DRIVE
C	USED TO WRITE THE DATA (IN SIXBIT)
C	S$APR  -- THE SERIAL NUMBER OF THE CPU WRITING THE DATA
C
	INTEGER S$SVER,S$FMT,S$BVER,S$DATE,S$DEV,S$APR
	PARAMETER (S$SVER=17,S$FMT=14,S$BVER=15,S$DATE=13,S$DEV=19,
	1 S$APR=18)
C
C	FOR UFD RECORDS:
C	D$STR  -- SIXBIT WORD CONTAINING THE STRUCTURE NAME
C	D$LVL  -- NUMBER FOR THE NESTING LEVEL OF THE
C	DIRECTORY.  0=UFD, 1-5=SFD LEVEL
C	D$PCHK -- CHECKSUM OF THE O$NAME FULL PATH NAME BLOCK
C
	INTEGER D$STR,D$LVL,D$PCHK
	PARAMETER (D$STR=13,D$LVL=14,D$PCHK=15)
C
C	FOR FILE DATA RECORDS:
C	F$PCHK -- CHECKSUM OF THE FULL PATHNAME BLOCK (O$NAME)
C	F$RDW  -- RELATIVE DATA WORD OF THE FIRST WORD ON TAPE
C	FOR THE FILE
C	F$PTH  -- A TWELVE WORD BLOCK USED TO STORE INFORMATION
C	SUITABLE TO RESTORE THE FILE.  IT HOLDS ENOUGH ROOM FOR
C	A TOPS-10 FILE IN A UFD OF UP TO 5 CHARACTERS EACH IN
C	THE PPN.  STORED AS 7 BIT BYTES AS: DATA TYPE, LENGTH IN
C	WORDS, ASCII DATA.  DATA TYPES ARE:  1=DEVICE, 2=FILENAME,
C	3=EXTENSION, 32+N=NTH DIRECTORY ENTRY.
C
	INTEGER F$PCHK,F$RDW,F$PTH
	PARAMETER (F$PCHK=13,F$RDW=14,F$PTH=15)
C
C	END OF DMPHEAD.FOR INCLUDE FILE
