C	START OF DMPREC.FOR INCLUDE FILE
C
C	THIS CONTAINS PARAMETERS FOR DUMPER/BACKUP OVERHEAD
C	REGIONS CONTAINED IN THE DATA PORTION OF RECORDS.
C	THESE REGIONS ARE PRECEEDED BY A WORD CONTAINING
C	A CONTROL WORD OF THE FORM:
C	LEFT HALF = TYPE OF REGION
C	RIGHT HALF = LENGTH OF REGION IN WORDS INCLUDING THIS WORD
C	ALLOWABLE TYPES ARE:
C	O$NAME -- TO GIVE THE FULL PATH IDENTIFICATION OF THE FILE
C	WITHOUT PUNCTUATION.  IT CONSISTS OF SEVERAL SUB-BLOCKS
C	THAT ARE DESCRIBED BELOW.
C	O$FILE -- A BLOCK CONTAINING THE FILE ATTRIBUTES.  IT HAS
C	A FIXED FORMAT THAT IS DESCRIBED BELOW.
C	O$DIRT -- RESERVED FOR DIRECTORY ATTRIBUTES
C	O$SYSN -- THE SYSTEM HEADER LINE IN ASCII FOLLOWED BY A
C	ZERO BYTE.
C	O$SSNM -- THE SAVE SET NAME IN ASCII FOLLOWED BY A ZERO BYTE.
C
	INTEGER O$FILE,O$DIRT,O$SYSN,O$SSNM
	PARAMETER (O$NAME=1,O$FILE=2,O$DIRT=3,O$SYSN=4,O$SSNM=5)
C
C	IN A O$NAME REGION:
C	THE SUB-BLOCKS ARE IN STANDARD ORDER; DEVICE, DIRECTORIES
C	(TOP DOWN), FILE NAME, EXTENSION, VERSION, AND GENERATION.
C	MISSING SUB-BLOCKS CORRESPOND TO PORTIONS OF THE PATH
C	SPECIFICATION THAT ARE OMITTED.  EACH SUB-BLOCK IS OF THE
C	FORM:
C	LEFT HALF  -- TYPE OF SUB-BLOCK
C	RIGHT HALF -- LENGTH OF SUB-BLOCK IN WORDS INCLUDING THIS ONE
C	THE REST OF EACH SUB-BLOCK IS AN ASCIZ (TRAILING ZERO BYTE)
C	STRING WITH NO LEADING OR IMBEDDED ZERO BYTES.
C	N$DEV  -- DEVICE NAME
C	N$NAME -- FILE NAME
C	N$EXT  -- EXTENSION
C	N$VER  -- VERSION
C	N$GEN  -- GENERATION
C	N$UFD  -- USER FILE DIRECTORY
C	N$SFD1 -- SUB-FILE DIRECTORY (LEVEL 1)
C	N$SFD2 THROUGH 5 ARE OTHER SFD'S (LEVEL 2 THROUGH 5)
C
	INTEGER N$DEV,N$NAME,N$EXT,N$VER,N$GEN,N$UFD,N$SFD1,
	1 N$SFD2,N$SFD3,N$SFD4,N$SFD5
	PARAMETER (N$DEV=1,N$NAME=2,N$EXT=3,N$VER=4,N$GEN=5,
	1 N$UFD=32,N$SFD1=33,N$SFD2=34,N$SFD3=35,N$SFD4=36,N$SFD5=37)
C
C	FOR FILE ATTRIBUTE BLOCKS:
C	THIS IS A FIXED REGION WITH THE FOLLOWING OFFSETS:
C	A$FHLN -- LENGTH IN WORDS OF THE HEADER
C	A$FLGS -- RESERVED FOR FLAGS
C	A$WRIT -- DATE/TIME OF LAST WRITE
C	A$ALLS -- ALLOCATED SIZE IN WORDS
C	A$MODE -- MODE OF LAST WRITE
C	A$LENG -- LENGTH IN BYTES
C	A$BSIZ -- BYTE SIZE (7 OR 36)
C	A$VERS -- VERSION ID (.JBVER FORMAT)
C	THE DATE/TIME ENTRY IS IN DEC-10 UNIVERSAL FORMAT WITH
C	THE LEFT HALF BEING THE NUMBER OF DAYS SINCE NOV. 17, 1858,
C	AND THE RIGHT HALF BEING THE FRACTION OF THE DAY.
C
	INTEGER A$FHLN,A$FLGS,A$WRIT,A$ALLS,A$MODE,A$LENG,A$BSIZ,A$VERS
	PARAMETER (A$FHLN=1,A$FLGS=2,A$WRIT=3,A$ALLS=4,A$MODE=5,
	1 A$LENG=6,A$BSIZ=7,A$VERS=8)
C
C	END OF DMPREC.FOR INCLUDE FILE
