	PROGRAM SHORTEN
C
C	This program shortens a BACKUP log file by removing
C	the message information and by listing the directory
C	name once instead of with each file.
C
	CHARACTER*64 FILENM
	INTEGER*2 FILELN
	CHARACTER*80 LINE,LINE2
	INTEGER*2 LINELN
	CHARACTER*80 DIRNAME
	INTEGER*2 DIRLEN
	INTEGER*2 I,J,K
C
C	Initialize the program by getting the logfile name, opening
C	the input and output files, and by setting the 'old directory
C	name' to a nonsense value.
C
	CALL LIB$GET_FOREIGN(FILENM,'Enter name of BACKUP log file:  '
	1 ,FILELN)
	OPEN(UNIT=1,NAME=FILENM(1:FILELN),STATUS='OLD',READONLY,
	1 SHARED,ERR=980)
	OPEN(UNIT=2,NAME=FILENM(1:FILELN),CARRIAGECONTROL='LIST',
	1 STATUS='NEW',ERR=990)
	DIRNAME = ' '
	DIRLEN = 80
C
C	Start of main loop.  Input a line of text; stop on end of
C	file; throw out blank lines; adjust line length if needed.
C
100	CONTINUE
	READ(1,102,END=200) LINELN,LINE
102	FORMAT(Q,A)
	IF (LINELN.EQ.0) GOTO 100
	LINELN = MIN(LINELN,80)
C
C	Check to see if this is a new directory name.  If so,
C	then get its name for later comparisons and write it
C	out to the file.
C
	IF (INDEX(LINE(1:LINELN),DIRNAME(1:DIRLEN)).EQ.0) THEN
	 I = INDEX(LINE(1:LINELN),'_')
	 J = INDEX(LINE(I+1:LINELN),']')
	 DIRLEN = J+1
	 DIRNAME(1:DIRLEN) = LINE(I:I+J)
	 WRITE(2,105) DIRNAME(1:DIRLEN)
105	FORMAT(/,A)
	ENDIF
C
C	Did an error occur?  If so, write out the filename followed
C	by the next input line (the type of error).  If not, just
C	write out the filename.
C
110	FORMAT(A)
	I = INDEX(LINE(1:LINELN),']')+1
	IF (INDEX(LINE(1:I),'Error').NE.0) THEN
	 READ(1,102) K,LINE2
	 WRITE(2,110) LINE(I:LINELN) // ' ' // LINE2(1:K)
	ELSE
	 WRITE(2,110) LINE(I:LINELN)
	ENDIF
	GOTO 100
C
200	CONTINUE
	CLOSE(UNIT=1)
	CLOSE(UNIT=2)
	GOTO 1000
C
980	CONTINUE
	WRITE(6,985) FILENM(1:FILELN)
985	FORMAT(' Error opening input file ',A)
	GOTO 1000
990	CONTINUE
	WRITE(6,995) FILENM(1:FILELN)
995	FORMAT(' Error opening output file ',A)
	GOTO 1000
C
1000	CONTINUE
	END
