C     TABBER.FOR - ROUTINES TO HANDLE TAB IN VARIOUS NICE WAYS
C      *** DO NOT EDIT THIS FILE WITH TXE!!! YOU WILL DESTROY ***
C      *** MANY ESSENTIAL TABS, AND TABBER WILL BE CONFUSED! ***
C
C     WRITTEN BY NED FREED, 6-FEB-80
C
C     THESE ROUTINES ARE DERIVED FROM CODE USED IN "SOFTWARE TOOLS", BY
C     KERNIGHAN AND PLAUGHER, AND "THE SELECTION OF OPTIMAL TAB
C     SETTINGS", BY PETERSON, BITNER, AND HOWARD, CACM VOL 21 NO 12
C     PAGES 1004-1007.
C
C     THE VARIOUS SUBROUTINES IN THIS PACKAGE CAN BE USED BY
C     ANY PROGRAM. HOWEVER, TABBER ALSO INCLUDES A DRIVER PROGRAM FOR
C     GENERAL PURPOSE WORK WITH ADDING AND REMOVING TABS.
C
      PROGRAM TABBER
C
C     DEFINE VARIABLES
      INTEGER MAXCOL,M(256,256),LIN1(256),LIN2(256),INTABS(256)
      INTEGER OUTTAB(256),I,J,LEN1,LEN2,COMMND(38),ABSMAX
      INTEGER ACOUNT,RCOUNT
      CHARACTER*64 FILNAM
      LOGICAL INFIL,OUTFIL
C
      COMMON /CNTERS/ ACOUNT,RCOUNT
C
      DATA COMMND / 2H  ,2H  ,2HIN,2Hin,2HOU,2Hou,2HIW,2Hiw,
     *  2HOW,2How,2HIR,2Hir,2HOR,2Hor,2HIS,2His,2HOS,2Hos,
     *  2HIC,2Hic,2HOC,2Hoc,2HMA,2Hma,2HHE,2Hhe,2HEN,2Hen,
     *  2HDE,2Hde,2HOP,2Hop,2HGO,2Hgo,2HEX,2Hex,2HBE,2Hbe /
C
C     LOG USAGE IN LOCAL DATA FILE
C     (BUT NOT FOR THE EXPORT VERSION --KVC)
C     CALL USELOG('TABBER')
C
C     ACTIVATE TIMER
      CALL CONTROLT
C
C     IDENTIFY OURSELVES
      TYPE 490
490   FORMAT(' TABBER - Program to insert/delete tabs from files',//)
C
C     SET UP VARIOUS DEFAULT CONDITIONS
      ABSMAX = 255
      MAXCOL = ABSMAX
      ACOUNT = 0
      RCOUNT = 0
      CALL WIPTAB(INTABS,MAXCOL)
      CALL WIPTAB(OUTTAB,MAXCOL)
      CALL REGTAB(8,INTABS,MAXCOL)
      CALL REGTAB(8,OUTTAB,MAXCOL)
      INFIL = .FALSE.
      OUTFIL = .FALSE.
C
C     HERE TO PRINT OUT TAB CHANGE TOTALS
500   IF (ACOUNT.GT.0) TYPE 502,ACOUNT
502   FORMAT(' [Number of tabs added = ',I6,']')
      IF (RCOUNT.GT.0) TYPE 504,RCOUNT
504   FORMAT(' [Number of tabs removed = ',I6,']')
      ACOUNT = 0
      RCOUNT = 0
C
C     ASK FOR COMMAND INPUT
      TYPE 510
510   FORMAT(1X,'Command: ',$)
      READ (*,520,END=2500,ERR=500) LIN1(1)
520   FORMAT(1A2)
      DO 530 I = 1,38
        IF (LIN1(1).EQ.COMMND(I)) GO TO 540
530   CONTINUE
      TYPE 535
535   FORMAT(1X,'TABBER - Illegal command given')
      GO TO 500
540   GO TO (500,1000,1100,1200,1300,1400,1500,1600,1700,1800,
     *  1900,2000,2100,2200,2300,2400,2200,2500,2600) (I+1)/2
C
C     INPUT COMMAND - SET UP AN INPUT FILE
1000  TYPE 1010
1010  FORMAT(1X,'Input file name:',$)
      READ (*,1020,END=2500) I,FILNAM
1020  FORMAT(Q,A)
      OPEN (UNIT=10,ACCESS='SEQUENTIAL',FORM='FORMATTED'
     *  ,NAME=FILNAM(1:I),TYPE='OLD',ERR=1050,READONLY,
     *  RECL = MAXCOL)
      INFIL = .TRUE.
      GO TO 500
C
1050  TYPE 1060
1060  FORMAT(1X,'%TABBER - Bad filename given for input')
      CLOSE (UNIT=20)
      GO TO 500
C
C     OUTPUT COMMAND - SET UP AN OUTPUT FILE
1100  TYPE 1110
1110  FORMAT(1X,'Output file name:',$)
      READ (*,1120,END=2500) I,FILNAM
1120  FORMAT(Q,A)
      OPEN (UNIT=20,ACCESS='SEQUENTIAL',FORM='FORMATTED'
     *  ,NAME=FILNAM(1:I),TYPE='NEW',ERR=1150,RECL=MAXCOL,
     *  CARRIAGECONTROL='LIST')
      OUTFIL = .TRUE.
      GO TO 500
C
1150  TYPE 1160
1160  FORMAT(1X,'%TABBER - Bad filename given for output')
      CLOSE (UNIT=20)
      GO TO 500
C
C     IWIPE - WIPE OUT INPUT TAB SPEC
1200  CALL WIPTAB(INTABS,MAXCOL)
      GO TO 500
C
C     OWIPE - WIPE OUT OUTPUT TAB SPEC
1300  CALL WIPTAB(OUTTAB,MAXCOL)
      GO TO 500
C
C     IREG - SET REGULAR INPUT TABS
1400  TYPE 1410
1410  FORMAT(1X,'At what intervals:',$)
      READ (*,1420,END=2500) I
1420  FORMAT(I6)
      IF ((I.LE.0).OR.(I.GT.MAXCOL)) GO TO 3000
      CALL REGTAB(I,INTABS,MAXCOL)
      GO TO 500
C
C     OREG - SET REGULAR OUTPUT TABS
1500  TYPE 1510
1510  FORMAT(1X,'At what intervals:',$)
      READ (*,1520,END=2500) I
1520  FORMAT(I6)
      IF ((I.LE.0).OR.(I.GT.MAXCOL)) GO TO 3000
      CALL REGTAB(I,OUTTAB,MAXCOL)
      GO TO 500
C
C     ISET - SET A SPECIAL TAB STOP ON INPUT
1600  TYPE 1610
1610  FORMAT(1X,'At what position:',$)
      READ (*,1620,END=2500) I
1620  FORMAT(I6)
      IF ((I.LE.0).OR.(I.GT.MAXCOL)) GO TO 3000
      CALL SETTAB(I,INTABS,MAXCOL)
      GO TO 500
C
C     OSET - SET A SPECIAL TAB STOP ON OUTPUT
1700  TYPE 1710
1710  FORMAT(1X,'At what position:',$)
      READ (*,1720,END=2500) I
1720  FORMAT(I6)
      IF ((I.LE.0).OR.(I.GT.MAXCOL)) GO TO 3000
      CALL SETTAB(I,OUTTAB,MAXCOL)
      GO TO 500
C
C     ICLEAR - CLEAR A SPECIAL TAB STOP ON INPUT
1800  TYPE 1810
1810  FORMAT(1X,'At what position:',$)
      READ (*,1820,END=2500) I
1820  FORMAT(I6)
      IF ((I.LE.0).OR.(I.GT.MAXCOL)) GO TO 3000
      CALL CLRTAB(I,INTABS,MAXCOL)
      GO TO 500
C
C     OCLEAR - CLEAR A SPECIAL TAB STOP ON OUTPUT
1900  TYPE 1910
1910  FORMAT(1X,'At what position:',$)
      READ (*,1920,END=2500) I
1920  FORMAT(I6)
      IF ((I.LE.0).OR.(I.GT.MAXCOL)) GO TO 3000
      CALL CLRTAB(I,OUTTAB,MAXCOL)
      GO TO 500
C
C     MAXCOL - SETTABLE TO ALLOW LINE TRIMMING
2000  TYPE 2010
2010  FORMAT(1X,'Maximum line length:',$)
      READ (*,2020,END=2500) I
2020  FORMAT(I6)
      IF ((I.LE.0).OR.(I.GT.ABSMAX)) GO TO 3000
      MAXCOL = I
      GO TO 500
C
C     HELP - GIVE THE CRETIN HELP
2100  TYPE 2110
2110  FORMAT(' For complete information on TABBER, please refer to',/,
     1  ' the help file. A brief list of the commands follows:',//,
     2  5X,'IWIPE - Wipe out tab settings on input stream',/,
     3  5X,'OWIPE - Wipe out tab settings on output stream',/,
     4  5X,'INPUT - Establish the input file name',/,
     5  5X,'OUTPU - Establish the output file name',/,
     6  5X,'IREG  - Set tabs at regular intervals for input stream',/,
     7  5X,'OREG  - Set tabs at regular intervals for output stream',/,
     8  5X,'ISET  - Set a specific tab stop for input stream',/,
     9  5X,'OSET  - Set a specific tab stop for output stream',/,
     1  5X,'ICLEA - Clear a specific tab stop for input stream',/,
     2  5X,'OCLEA - Clear a specific tab stop for output stream',/,
     3  5X,'MAXCO - Set maximum line length. Useful for truncation',/,
     4  5X,'ENTAB - Copy input stream to output stream, modifying',/,
     5  5X,'        tabs in the process',/,
     6  5X,'DETAB - Copy input stream to output stream, removing',/,
     7  5X,'        all tabs according to input specs.',/,
     8  5X,'OPTIM - Read input stream and set optimum tabs for',/,
     9  5X,'        output of that stream')
      TYPE 2115
2115  FORMAT(5X,'BENTA - Same as ENTAB, except only spaces at the',/,
     1  5X,'        beginning of lines are converted on output',/,
     2  5X,'EXIT  - Exit program at once',//,
     3  ' The default settings are tabs at every 8th position on',/,
     4  ' input and output, and a maximum line length of 255. This',/,
     5  ' line length is also the absolute maximum.',//)
      GO TO 500
C
C     ENTAB - GO THROUGH THE FILE
2200  IF (.NOT.INFIL) GO TO 3100
      IF (.NOT.OUTFIL) GO TO 3200
2205  READ (10,2210,END=2250) I,(LIN1(I),I=1,MIN0(I,MAXCOL))
2210  FORMAT(Q,<MAXCOL>A1)
C
      IF (I-1.LE.0) GO TO 2230
      CALL TBLANK(LIN1,I-1,LEN1)
      CALL LDETAB(LIN1,LEN1,LIN2,LEN2,INTABS,MAXCOL)
      CALL LENTAB(LIN2,LEN2,LIN1,LEN1,OUTTAB,MAXCOL)
      WRITE (20,2220),(LIN1(J),J=1,LEN1)
2220  FORMAT(<LEN1>A1)
      GO TO 2205
C
2230  WRITE (20,2240)
2240  FORMAT()
      GO TO 2205
C
2250  CLOSE (UNIT=10)
      CLOSE (UNIT=20)
      TYPE 2260
2260  FORMAT(1X,'[Conversion complete]')
      INFIL = .FALSE.
      OUTFIL = .FALSE.
      GO TO 500
C
C     DETAB - GO THROUGH THE FILE
2300  IF (.NOT.INFIL) GO TO 3100
      IF (.NOT.OUTFIL) GO TO 3200
2305  READ (10,2310,END=2350) I,(LIN1(I),I=1,MIN0(I,MAXCOL))
2310  FORMAT(Q,<MAXCOL>A1)
C
      IF (I-1.LE.0) GO TO 2330
      CALL TBLANK(LIN1,I-1,LEN1)
      CALL LDETAB(LIN1,LEN1,LIN2,LEN2,INTABS,MAXCOL)
      WRITE (20,2320),(LIN2(J),J=1,LEN2)
2320  FORMAT(<LEN2>A1)
      GO TO 2305
C
2330  WRITE (20,2340)
2340  FORMAT()
      GO TO 2305
C
2350  CLOSE (UNIT=10)
      CLOSE (UNIT=20)
      TYPE 2360
2360  FORMAT(1X,'[Conversion complete]')
      INFIL = .FALSE.
      OUTFIL = .FALSE.
      GO TO 500
C
C     OPTIM - READ FILE AND OPTIMIZE TABS ON OUTPUT SPEC
C        NO OUTPUT IS DONE. THE INPUT FILE IS ALSO RESET FOR FUTURE
C        USE IF NECESSARY.
2400  IF (.NOT.INFIL) GO TO 3100
      CALL OPTREA(10,INTABS,OUTTAB,LIN1,LIN2,M,MAXCOL)
      GO TO 500
C
C     EXIT - EXIT THE PROGRAM NICELY
2500  STOP
C
C     BENTA - GO THROUGH THE FILE, ONLY DO BEGINNINGS
2600  IF (.NOT.INFIL) GO TO 3100
      IF (.NOT.OUTFIL) GO TO 3200
2605  READ (10,2610,END=2650) I,(LIN1(I),I=1,MIN0(I,MAXCOL))
2610  FORMAT(Q,<MAXCOL>A1)
C
      IF (I-1.LE.0) GO TO 2630
      CALL TBLANK(LIN1,I-1,LEN1)
      CALL LDETAB(LIN1,LEN1,LIN2,LEN2,INTABS,MAXCOL)
      CALL LENTBF(LIN2,LEN2,LIN1,LEN1,OUTTAB,MAXCOL)
      WRITE (20,2620),(LIN1(J),J=1,LEN1)
2620  FORMAT(<LEN1>A1)
      GO TO 2605
C
2630  WRITE (20,2640)
2640  FORMAT()
      GO TO 2605
C
2650  CLOSE (UNIT=10)
      CLOSE (UNIT=20)
      TYPE 2660
2660  FORMAT(1X,'[Conversion complete]')
      INFIL = .FALSE.
      OUTFIL = .FALSE.
      GO TO 500
C
C     HERE IF ILLEGAL PARAMETER GIVEN
3000  TYPE 3010
3010  FORMAT(1X,'%TABBER - Illegal position parameter given')
      GO TO 500
C
C     HERE IF INPUT FILE NOT SPECIFIED
3100  TYPE 3110
3110  FORMAT(1X,'%TABBER - Input file not specified')
      GO TO 500
C
C     HERE IF OUTPUT FILE NOT SPECIFIED
3200  TYPE 3210
3210  FORMAT(1X,'%TABBER - Output file not specified')
      GO TO 500
C
C     END OF PROGRAM TABBER
      END
C
C
C
C     OPTTAB - SET UP OPTIMUM TABS SPACING BASED ON FREQUENCY COUNTS
C       CALL OPTTAB(M,MAXCOL,TABS)
C       ARGUMENTS:
C         M - A 2 DIMENSIONAL ARRAY OF DIMENSION MAXCOL, WHICH CONTAINS
C             IN AN ELEMENT (I,J) THE NUMBER OF SEQUENCES OF BLANKS
C             WHICH BEGIN AT OR BEFORE COLUMN I AND END IN COLUMN J-1.
C         MAXCOL - THE ACTUAL DIMENSION OF M AND TABS. THIS MUST BE
C             LESS THAN 300.
C         TABS - ON EXIT, TABS(I) WILL CONTAIN THE COLUMN TO WHICH
C             A TAB IN COLUMN I SHOULD MOVE.
C
      SUBROUTINE OPTTAB(M,MAXCOL,TABS)
C
C     VARIABLE DECLARATIONS
      INTEGER M(MAXCOL,MAXCOL),TABS(MAXCOL)
      INTEGER SAVE(300),PREV(300),ROWSUM(300)
      INTEGER I,J,COL,SUM
C
C     INITIALIZE FOR PICKING TABS
      SAVE(1) = 0
      SAVE(2) = 0
      PREV(1) = 0
      PREV(2) = 0
      SUM = 0
C
      DO 10 J = 3,MAXCOL
        SUM = SUM + M(1,J)
10    CONTINUE
      ROWSUM(1) = SUM
C
C     THE ROWSUM ARRAY IS USED TO AVOID RECOMPUTING SUMS IN M. AT THE
C     BEGINNING OF EACH ITERATION OF THE FOLLOWING LOOP, ROWSUM(1),
C     ROWSUM(2) ... ROWSUM(COL-2) ARE DEFINED, WITH ROWSUM(K)=M(K,COL)
C     + M(K,COL+1) + ... M(K,MAXCOL). FOR EACH COLUMN COL, WE CALCULATE
C     THE GAIN (SAVE) FROM A TAB STOP IN THAT COLUMN AND THE BEST
C     PREVIOUS TAB STOP FOR THIS COLUMN (PREV).
      DO 50 COL = 3,MAXCOL
        TOTAL = 0
        DO 20 I = 1,COL-2
          TOTAL = TOTAL + ROWSUM(I)
20      CONTINUE
        SAVE(COL) = TOTAL
        PREV(COL) = 0
        DO 30 I = 2,COL-1
          TOTAL = TOTAL - ROWSUM(I-1)
          ROWSUM(I-1) = ROWSUM(I-1) - M(I-1,COL)
          IF (TOTAL+SAVE(I).LE.SAVE(COL)) GO TO 30
          SAVE(COL) = TOTAL + SAVE(I)
          PREV(COL) = I
30      CONTINUE
        SUM = 0
        DO 40 J = COL+1,MAXCOL
          SUM = SUM + M(COL-1,J)
40      CONTINUE
        ROWSUM(COL-1) = SUM
50    CONTINUE
C
C     CREATE TAB ARRAY
      J = MAXCOL
60    IF (J.LE.0) GO TO 80
      I = PREV(J)
      DO 70 COL = I,J-1
        TABS(COL) = J
70    CONTINUE
      J = I
      GO TO 60
C
80    TABS(MAXCOL) = MAXCOL + 1
      RETURN
C
C     END OF SUBROUTINE OPTTAB
      END
C
C
C
C     LDETAB - ROUTINE TO REMOVE TABS FROM A LINE
C       CALL: CALL LDETAB(LINE1,LEN1,LINE2,LEN2,TABS,MAXCOL)
C       ARGUMENTS:
C         LINE1 - THE INPUT LINE STORED IN AN INTEGER ARRAY.
C         LEN1 - THE LENGTH OF THE LINE IN LINE1.
C         LINE2 - THE RESULTANT LINE WITH ALL TABS CONVERTED TO
C                 SPACES ON OUTPUT, ALSO STORED IN AN INTEGER ARRAY.
C         LEN2 - THE RESULTANT LENGTH OF THE LINE IN LINE2.
C         TABS - A DESCRIPTOR ARRAY TELLING WHERE THE TAB STOPS ARE.
C         MAXCOL - THE MAXIMUM LENGTH OF A LINE.
C
      SUBROUTINE LDETAB(LINE1,LEN1,LINE2,LEN2,TABS,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER LINE1(MAXCOL),LINE2(MAXCOL),TABS(MAXCOL),MAXCOL
      INTEGER LEN1,LEN2,LP1,LP2,TAB,SPACE,ACOUNT,RCOUNT
C
      COMMON /CNTERS/ ACOUNT,RCOUNT
C
      DATA SPACE /1H /
      DATA TAB /1H	/
C
      LP2 = 1
      DO 100 LP1 = 1,LEN1
        IF (LINE1(LP1).EQ.TAB) GO TO 50
        LINE2(LP2) = LINE1(LP1)
        LP2 = LP2 + 1
        IF (LP2.GT.MAXCOL) GO TO 125
        GO TO 100
50      RCOUNT = RCOUNT + 1
        DO 75 LP2 = LP2,TABS(LP2)-1
          LINE2(LP2) = SPACE
75      CONTINUE
100   CONTINUE
C
125   LEN2 = LP2 - 1
      RETURN
C
C     END OF SUBROUTINE LDETAB
      END
C
C
C
C     LINOPT - ROUTINE TO READ STRING AND SET UP THE M ARRAY
C       CALL: CALL LINOPT(LINE,LENGTH,M,MAXCOL)
C       ARGUMENTS:
C         LINE - THE LINE TO SCAN, STORED IN AN INTEGER ARRAY.
C         LENGTH - THE LENGTH OF THE LINE. TRAILING SPACES SHOULD
C                HAVE BEEN TRIMMED ALREADY.
C         M - THE UPPER RIGHT TRIANGULAR ARRAY TO BE USED BY OPTTAB.
C                THIS AN INTEGER ARRAY DIMENSIONED MAXCOL X MAXCOL.
C         MAXCOL - THE MAXIMUM LENGTH OF A LINE. THIS IS USED TO
C                DIMENSION LINE AND M.
C
      SUBROUTINE LINOPT(LINE,LENGTH,M,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER LINE(MAXCOL),M(MAXCOL,MAXCOL),MAXCOL,LENGTH
      INTEGER I,J,SPACE
C
      DATA SPACE /1H /
C
      I = 1
50    DO 100 I = I,LENGTH
        IF (LINE(I).EQ.SPACE) GO TO 200
100   CONTINUE
      RETURN
C
200   J = I
      DO 300 I = I,LENGTH
        IF (LINE(I).NE.SPACE) GO TO 400
300   CONTINUE
C
400   DO 500 J = J,I-1,1
        M(J,I) = M(J,I) + 1
500   CONTINUE
C
      IF (I.LT.MAXCOL) GO TO 50
      RETURN
C
C     END OF SUBROUTINE LINOPT
      END
C
C
C
C     INIOPT - ROUTINE TO INITIALIZE THE M ARRAY FOR OPTTAB
C       CALL: CALL INIOPT(M,MAXCOL)
C       ARGUMENTS:
C         M - THE ARRAY USED BY OPTTAB, DIMENSIONED MAXCOL X MAXCOL.
C         MAXCOL - THE MAXIMUM VALID COLUMN FOR A LINE.
C
      SUBROUTINE INIOPT(M,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER MAXCOL,M(MAXCOL,MAXCOL),I,J
C
      DO 200 I = 1,MAXCOL
        DO 100 J = 1,MAXCOL
          M(I,J) = 0
100     CONTINUE
200   CONTINUE
      RETURN
C
C     END OF SUBROUTINE INIOPT
      END
C
C
C
C      SETTAB - ROUTINE TO SET A SPECIFIC TAB STOP
C        CALL: CALL SETTAB(COL,TABS,MAXCOL)
C        ARGUMENTS:
C          COL - INTEGER TELLING WHICH COLUMN TO PUT THE STOP IN.
C          TABS - A TAB DESCRIPTOR ARRAY (INTEGER, OF DIMENSION MAXCOL).
C          MAXCOL - THE MAXIMUM LENGTH OF A LINE.
C
      SUBROUTINE SETTAB(COL,TABS,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER COL,TABS(MAXCOL),MAXCOL,I
C
      DO 100 I = COL-1,1,-1
        IF (TABS(I).LE.COL) RETURN
        TABS(I) = COL
100   CONTINUE
C
C     END OF SUBROUTINE SETTAB
      END
C
C
C
C      CLRTAB - ROUTINE TO CLEAR A SPECIFIC TAB STOP
C        CALL: CALL CLRTAB(COL,TABS,MAXCOL)
C        ARGUMENTS:
C          COL - INTEGER TELLING WHICH COLUMN TO CLEAR THE TAB FROM.
C          TABS - A TAB DESCRIPTOR ARRAY (INTEGER, OF DIMENSION MAXCOL).
C          MAXCOL - THE MAXIMUM LENGTH OF A LINE.
C
      SUBROUTINE CLRTAB(COL,TABS,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER COL,TABS(MAXCOL),MAXCOL,I
C
      DO 100 I = COL-1,1,-1
        IF (TABS(I).NE.COL) RETURN
        TABS(I) = TABS(COL+1)
100   CONTINUE
C
C     END OF SUBROUTINE CLRTAB
      END
C
C
C
C     REGTAB - ROUTINE TO SET REGULAR TAB STOPS
C       CALL: CALL REGTAB(INC,TABS,MAXCOL)
C       ARGUMENTS:
C         INC - INCREMENT TO SET TABS AT.
C         TABS - A TAB DESCRIPTOR ARRAY.
C         MAXCOL - MAXIMUM LEGAL COLUMN.
C
      SUBROUTINE REGTAB(INC,TABS,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER INC,TABS(MAXCOL),MAXCOL,I
C
      DO 100 I = INC,MAXCOL,INC
        IF (I.LT.MAXCOL) CALL SETTAB(I+1,TABS,MAXCOL)
100   CONTINUE
C
C     END OF SUBROUTINE REGTAB
      END
C
C
C
C     LENTAB - ROUTINE TO ADD TABS TO A LINE
C       *** THE LINE SHOULD HAVE NO TABS IN IT PRIOR TO THIS CALL ***
C       CALL: CALL LENTAB(LINE1,LEN1,LINE2,LEN2,TABS,MAXCOL)
C       ARGUMENTS:
C         LINE1 - THE INPUT LINE STORED IN AN INTEGER ARRAY.
C         LEN1 - THE LENGTH OF THE LINE IN LINE1.
C         LINE2 - THE RESULTANT LINE WITH ALL TABS CONVERTED TO
C                 SPACES ON OUTPUT, ALSO STORED IN AN INTEGER ARRAY.
C         LEN2 - THE RESULTANT LENGTH OF THE LINE IN LINE2.
C         TABS - A DESCRIPTOR ARRAY TELLING WHERE THE TAB STOPS ARE.
C         MAXCOL - THE MAXIMUM LENGTH OF A LINE.
C
      SUBROUTINE LENTAB(LINE1,LEN1,LINE2,LEN2,TABS,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER LINE1(MAXCOL),LINE2(MAXCOL),TABS(MAXCOL),MAXCOL
      INTEGER LEN1,LEN2,LP1,LP2,LP1SAV,TAB,SPACE,ACOUNT,RCOUNT
C
      COMMON /CNTERS/ ACOUNT,RCOUNT
C
      DATA SPACE /1H /
      DATA TAB /1H	/
C
      LP1 = 1
      LP2 = 1
50    DO 100 LP1 = LP1,LEN1
        IF (LINE1(LP1).EQ.SPACE) GO TO 200
        LINE2(LP2) = LINE1(LP1)
        LP2 = LP2 + 1
100   CONTINUE
      LEN2 = LP2 - 1
      RETURN
C
200   LP1SAV = LP1
      DO 300 LP1 = LP1,LEN1
        IF (LINE1(LP1).NE.SPACE) GO TO 400
300   CONTINUE
C
400   IF (TABS(LP1SAV).GT.LP1) GO TO 600
      ACOUNT = ACOUNT + 1
      LINE2(LP2) = TAB
      LP2 = LP2 + 1
      LP1SAV = TABS(LP1SAV)
      IF (LP1SAV.GE.MAXCOL) GO TO 600
      GO TO 400
C
600   IF (LP1SAV.EQ.LP1) GO TO 800
      DO 700 LP1SAV = LP1SAV,LP1-1
        LINE2(LP2) = SPACE
        LP2 = LP2 + 1
700   CONTINUE
800   IF (LP1.LE.LEN1) GO TO 50
      LEN2 = LP2 - 1
      RETURN
C
C     END OF SUBROUTINE LENTAB
      END
C
C
C
C     LENTBF - ROUTINE TO ADD TABS TO A LINE AT BEGINNING ONLY
C       *** THE LINE SHOULD HAVE NO TABS IN IT PRIOR TO THIS CALL ***
C       CALL: CALL LENTBF(LINE1,LEN1,LINE2,LEN2,TABS,MAXCOL)
C       ARGUMENTS:
C         LINE1 - THE INPUT LINE STORED IN AN INTEGER ARRAY.
C         LEN1 - THE LENGTH OF THE LINE IN LINE1.
C         LINE2 - THE RESULTANT LINE WITH ALL TABS CONVERTED TO
C                 SPACES ON OUTPUT, ALSO STORED IN AN INTEGER ARRAY.
C         LEN2 - THE RESULTANT LENGTH OF THE LINE IN LINE2.
C         TABS - A DESCRIPTOR ARRAY TELLING WHERE THE TAB STOPS ARE.
C         MAXCOL - THE MAXIMUM LENGTH OF A LINE.
C
      SUBROUTINE LENTBF(LINE1,LEN1,LINE2,LEN2,TABS,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER LINE1(MAXCOL),LINE2(MAXCOL),TABS(MAXCOL),MAXCOL
      INTEGER LEN1,LEN2,LP1,LP2,LP1SAV,TAB,SPACE,ACOUNT,RCOUNT
C
      COMMON /CNTERS/ ACOUNT,RCOUNT
C
      DATA SPACE /1H /
      DATA TAB /1H	/
C
      LP1 = 1
      LP2 = 1
50    DO 100 LP1 = LP1,LEN1
        IF (LINE1(LP1).NE.SPACE) GO TO 200
100   CONTINUE
C
C     HERE WHEN WE HAVE THE FIRST NON-SPACE ON THE LINE
200   LP1SAV = LP1
      LP1 = 1
300   IF (TABS(LP1).GT.LP1SAV) GO TO 400
      ACOUNT = ACOUNT + 1
      LINE2(LP2) = TAB
      LP2 = LP2 + 1
      LP1 = TABS(LP1)
      GO TO 300
C
C     COPY OVER THE REST OF THE LINE
400   DO 500 LP1 = LP1,LEN1
        LINE2(LP2) = LINE1(LP1)
        LP2 = LP2 + 1
500   CONTINUE
C
      LEN2 = LP2 - 1
      RETURN
C
C     END OF SUBROUTINE LENTBF
      END
C
C
C
C     WIPTAB - ROUTINE TO WIPE OUT ALL TAB SETTINGS
C       CALL: CALL WIPTAB(TABS,MAXCOL)
C       ARGUMENTS:
C         TABS - STANDARD TABS INFO ARRAY.
C         MAXCOL - MAXIMUM LINE LENGTH.
C
      SUBROUTINE WIPTAB(TABS,MAXCOL)
C
C     DECLARE VARIABLES
      INTEGER TABS(MAXCOL),MAXCOL
C
      DO 100 I = 1,MAXCOL
        TABS(I) = MAXCOL
100   CONTINUE
      RETURN
C
C     END OF SUBROUTINE WIPTAB
      END
C
C
C
C     TBLANK - ROUTINE TO STRIP THE TRAILING BLANKS OFF A LINE
C       CALL: CALL TBLANK(LINE,MAXCOL,LENGTH)
C       ARGUMENTS:
C         LINE - THE LINE TO BE WORKED ON, STORED IN AN INTEGER ARRAY
C                OF DIMENSION MAXCOL.
C         MAXCOL - THE MAXIMUM LENGTH OF A LINE.
C         LENGTH - THE RESULTANT LENGTH OF THE STRING. SPACES ARE NOT
C                REMOVED, BUT THE LENGTH WORD CAN BE USED TO TRUNCATE
C                IF DESIRED.
C
      SUBROUTINE TBLANK(LINE,MAXCOL,LENGTH)
C
C     DECLARE VARIABLES
      INTEGER LINE(MAXCOL),MAXCOL,LENGTH,SPACE,TAB
C
      DATA SPACE /1H /
      DATA TAB /1H	/
C
      DO 100 LENGTH = MAXCOL,1,-1
        IF ((LINE(LENGTH).NE.SPACE).AND.(LINE(LENGTH).NE.TAB)) RETURN
100   CONTINUE
      RETURN
C
C     END OF SUBROUTINE TBLANK
      END
C
C
C
C     OPTREA - READ A FILE AND PRODUCE THE OPTIMUM TAB SETS FOR IT
C       CALL: CALL OPTREA(CHANNL,INTABS,OUTTAB,LIN1,LIN2,M,MAXCOL)
C       ARGUMENTS:
C         CHANNL - THE CHANNEL TO READ THE FILE FROM.
C         INTABS - THE TABS THAT THE INPUT FILE IS SET WITH.
C         OUTTAB - THE ARRAY TO PUT THE FINAL TAB SETS IN.
C         LIN1, LIN2, M - SCRATCH AREAS USED BY OPTREA. LIN1 AND LIN2
C              SHOULD BE DIMENSIONED MAXCOL, AND M AS MAXCOL * MAXCOL.
C         MAXCOL - THE MAXIMUM LENGTH OF A STRING.
C
      SUBROUTINE OPTREA(CHANNL,INTABS,OUTTAB,LIN1,LIN2,M,MAXCOL)
C
C     VARIABLE DECLARATIONS
      INTEGER MAXCOL,CHANNL,INTABS(MAXCOL),OUTTAB(MAXCOL),LIN1(MAXCOL)
      INTEGER LIN2(MAXCOL),M(MAXCOL,MAXCOL),LEN1,LEN2
C
C     INITIALIZE FIRST
      CALL INIOPT(M,MAXCOL)
C
100   READ (CHANNL,110,END=300) LIN1
110   FORMAT(A1)
C
      CALL TBLANK(LIN1,MAXCOL,LEN1)
      CALL LDETAB(LIN1,LEN1,LIN2,LEN2,INTABS,MAXCOL)
      CALL LINOPT(LIN2,LEN2,M,MAXCOL)
      GO TO 100
C
300   CALL OPTTAB(M,MAXCOL,OUTTAB)
      REWIND CHANNL
      RETURN
C
C     END OF TABBER.FOR
      END
