$	save_verify = 'f$verify(0)'
$	goto skipheader
$ !
$ !	parsfile.com
$ !
$ !	This DCL procedure takes a fully qualified VAX file specification
$ !	as the parameter and returns the node, device, directory, filename,
$ !	extension and version.  Anything not present in the file specification
$ !	is returned as the null string.
$ !
$ !	Created:   BMcLay       7-May-1981
$ !	Modified:
$ !
$ skipheader:
$ !
$	file_spec     := 'p1'
$	pfs_node      :==
$	pfs_device    :==
$	pfs_directory :==
$	pfs_file_name :==
$	pfs_extension :==
$	pfs_version   :==
$ !
$	flen = 'f$length(file_spec)
$	fd = 'f$locate("::", file_spec)
$	if fd .ge. flen then goto get_device
$		pfs_node :== 'f$extract(0, fd, file_spec)
$		off = fd + 2
$		flen = flen - off
$		file_spec := 'f$extract(off, flen, file_spec)
$ !
$ get_device:
$	if flen .le. 0 then goto done
$	fd = 'f$locate(":", file_spec)
$	if fd .ge. flen then goto get_directory
$		pfs_device :== 'f$extract(0, fd, file_spec)
$		off = fd + 1
$		flen = flen - off
$		file_spec := 'f$extract(off, flen, file_spec)
$ !
$ get_directory:
$	if flen .le. 0 then goto done
$	fd = 'f$locate("]", file_spec)
$	if fd .lt. flen then goto dir50
$	fd = 'f$locate(">", file_spec)
$	if fd .ge. flen then goto get_file_name
$	dir50:
$		fd = fd - 1
$		pfs_directory :== 'f$extract(1, fd, file_spec)
$		off = fd + 2
$		flen = flen - off
$		file_spec := 'f$extract(off, flen, file_spec)
$ !
$ get_file_name:
$	if flen .le. 0 then goto done
$	fd = 'f$locate(".", file_spec)
$	if fd .lt. flen then goto fil50
$	fd = 'f$locate(";", file_spec)
$	fil50:
$		if fd .le. 0 then goto get_extension	! null file name
$		pfs_file_name :== 'f$extract(0, fd, file_spec)
$		flen = flen - fd
$		file_spec := 'f$extract(fd, flen, file_spec)
$ !
$ get_extension:
$	if flen .le. 0 then goto done
$	fd = 'f$locate(".", file_spec)
$	if fd .ge. flen then goto get_version
$	fd = fd + 1
$	flen = flen - fd
$	file_spec := 'f$extract(fd, flen, file_spec)
$	if flen .le. 0 then goto done
$	fd = 'f$locate(";", file_spec)
$	if fd .lt. flen then goto ext50
$	fd = 'f$locate(".", file_spec)
$	ext50:
$		if fd .le. 0 then goto get_version	! null extension
$		pfs_extension :== 'f$extract(0, fd, file_spec)
$		flen = flen - fd
$		file_spec := 'f$extract(fd, flen, file_spec)
$ !
$ get_version:
$	fd = 'f$locate(";", file_spec)
$	if fd .lt. flen then goto ver50
$	fd = 'f$locate(".", file_spec)
$	if fd .ge. flen then goto done
$	ver50:
$		fd = fd + 1
$		flen = flen - fd
$		pfs_version :== 'f$extract(fd, flen, file_spec)
$ !
$ done:
$ !	Output for debugging
$ !	write sys$output "file_spec     = ", file_spec
$ !	write sys$output "pfs_node      = ", pfs_node
$ !	write sys$output "pfs_device    = ", pfs_device
$ !	write sys$output "pfs_directory = ", pfs_directory
$ !	write sys$output "pfs_file_name = ", pfs_file_name
$ !	write sys$output "pfs_extension = ", pfs_extension
$ !	write sys$output "pfs_version   = ", pfs_version
$
$	if save_verify then set verify
$	exit
