PROGRAM vq(LOGFILE);

{

This software is provided at no charge, and there is
no warranty. Permission to copy is granted without
conditions.

        David A. Johnson
        VAX System Manager
        Lockheed Palo Alto Research Lab
        Dept. 5233, Bldg 255
        3251 Hanover St.
        Palo Alto, CA 94304
        (415) 858-4038

                                               }


CONST

  maxq = 2;

{
   Global Section Constants.
				}

  sec$m_gbl	= %X00000001;
  sec$m_perm	= %X00004000;
  sec$m_sysgbl	= %X00008000;
  sec$m_wrt	= %X00000008;
{
    Input/Output Constants
				}
  io$_readvblk  = %X00000031;
  io$_writevblk = %X00000030;
  io$_setmode   = %X00000023;
  io$m_now      = %X00000040;
  io$m_wrtattn  = %X00000100;
{
   System Service Constants
				}
  ss$_normal	= %X00000001;
  ss$_created	= %X00000619;
  ss$_duplnam   = %X00000094;
  ss$_noslot    = %X0000039C;

  enable        = 1;
  disable       = 0;

  errlog = 'SYS$SYSDISK:[SYSMGR]PSPOOL.LOG';

TYPE

%INCLUDE 'BASICTYPE.PAS'

%INCLUDE 'PLTSEC.PAS'

%INCLUDE 'JBCSEC.PAS'

dbl = PACKED RECORD
    CASE BOOLEAN OF
	 TRUE:(pq1,pq2:secptr);
	FALSE:(pj1,pj2:jbcptr)
    END;

  two_wrds = PACKED ARRAY [1..2] OF word;

  equiv = PACKED RECORD
  	CASE INTEGER OF
  		 1:(alpha:alfa4);
  		 2:( numb:INTEGER);
  		 3:( twin:two_wrds)
  	END;

ioblock = PACKED RECORD
		iostat,byte_count:word;
		process_id:INTEGER
	  END;

nmsg = 0..3;

action_type = (plot, delete, initq, delq, startq, stopq, abortq, nogood);

VAR

  equic:equiv;
  p:secptr;
  q:jbcptr;
  rnam,snam:ARRAY [1..7] OF alfa6;
  rchan,schan:ARRAY [1..7] OF word;
  proc_nam:ARRAY [1..7] OF alfa8;
  idx:INTEGER;
  dlevel:INTEGER;
  blanks:alfa132;
  job_no:INTEGER;	{ Current Entry # }
  vqabort:BOOLEAN;
  half_min:quadword;
  pschan:word;	{ Mailbox channels }
  active_pid:ARRAY [1..7] OF longword;
  cmd0,cmd1,cmd2,cmd3,cmd4,cmd5:alfa30;
  LOGFILE:TEXT;

VALUE

  cmd0 := '$ SET NOVERIFY                ';
  cmd1 := '$ STOP/QUEUE/NEXT       xxxx: ';
  cmd2 := '$ SET DEVICE/NOSPOOL    xxxx: ';
  cmd3 := '$ SET DEVICE/SPOOL=xxxx xxxx: ';
  cmd4 := '$ START/QUEUE           xxxx: ';
  cmd5 := '$ STOP/IDENTIFICATION=0       ';

{/******************************************************\
 |                                                      |
 |                      Externals                       |
 |                                                      |
 \******************************************************/}

FUNCTION  sys$crmpsc   (inadr:dbl;
			VAR retadr:dbl;
			%IMMED acmode,flags:longword;
			%STDESCR gsdnam:alfa9;
			%IMMED ident,relpag,chan,
				pagcnt,vbn:INTEGER;
			%IMMED prot:word;
			%IMMED pfc:longword):INTEGER;EXTERN;
FUNCTION sys$mgblsc	(inadr:dbl;
			 VAR retadr:dbl;
			 %IMMED acmode,flags:longword;
			 %STDESCR gsdnam:alfa9;
			 %IMMED ident,
			  relpag:INTEGER):INTEGER;EXTERN;

FUNCTION sys$setast (%IMMED enabl:INTEGER):INTEGER;EXTERN; 

FUNCTION sys$qiow 	(%IMMED efn,chan,func:INTEGER;
			iosb:ioblock;
			%IMMED astadr,astprm:INTEGER;
			buffer:alfa132;
     		     %IMMED bsize,p3,p4,p5,p6:INTEGER):INTEGER;EXTERN;

FUNCTION sys$qio        (%IMMED efn,chan,func:INTEGER;
	                  VAR iosb:ioblock;
			  %IMMED astadr,astprm:INTEGER;
			  %IMMED PROCEDURE asthdlr;
			  %IMMED p2,p3,p4,
        		  	p5,p6:INTEGER):INTEGER;EXTERN;

FUNCTION sys$crembx(%IMMED prmflg:INTEGER;
  		    VAR chan:word;
		    %IMMED maxmsg,bufquo,promsk,acmode:INTEGER;
		    %STDESCR lognam:alfa6):INTEGER;EXTERN;

FUNCTION sys$delmbx(%IMMED chan:word):INTEGER;EXTERN;

FUNCTION sys$alloc   (%STDESCR dev:alfa6;
  			%IMMED pl, pb, acmode:INTEGER):INTEGER;EXTERN;

FUNCTION sys$dalloc(%STDESCR dev:alfa6;
  		    %IMMED acm:INTEGER):INTEGER;EXTERN;
                 
FUNCTION sys$hiber:INTEGER;EXTERN;

FUNCTION sys$wake(%IMMED pid,prc:INTEGER):INTEGER;EXTERN;

FUNCTION sys$dassgn(%IMMED chan:INTEGER):INTEGER;EXTERN;

FUNCTION sys$gettim(VAR time:quadword):INTEGER;EXTERN;

FUNCTION sys$delprc(id:INTEGER;%IMMED pn:INTEGER):INTEGER;EXTERN;

FUNCTION LIB$EXECUTE_CLI(%STDESCR c1,c2,c3:alfa30):INTEGER;EXTERN;

PROCEDURE useropen (VAR chan,stat:INTEGER);EXTERN;

PROCEDURE addr1(VAR adr:dbl);EXTERN;

PROCEDURE addr2(VAR adr:dbl);EXTERN;

PROCEDURE listen_to_users;FORWARD;
 
{ FUNCTION sys$setast(enabl:INTEGER):INTEGER;
BEGIN
IF enabl = 1 THEN dlevel := dlevel - 1
             ELSE dlevel := dlevel + 1;
WRITELN(LOGFILE, ' In setast: switch is ', enabl:1, ' level is ', dlevel:1);
END;
			}


PROCEDURE debug(info:alfa6);
BEGIN
WRITELN(LOGFILE, ' Debug at ', info);
END;

{/******************************************************\
 |                                                      |
 |                    INITIALIZE_VQ                     |
 |                                                      |
 \******************************************************/}

PROCEDURE initialize_vq;
VAR
  delta_string:alfa6;
  k,st:INTEGER;
  ch:CHAR;

  FUNCTION sys$bintim(%STDESCR dt:alfa6;
  		      VAR hf:quadword):INTEGER;EXTERN;
BEGIN
dlevel := 0;
vqabort := FALSE;
FOR st := 1 TO 132 DO blanks[st] := ' ';
delta_string := '0 ::05';
st := sys$bintim(delta_string, half_min);
FOR k := 1 TO 7 DO
  BEGIN
  proc_nam[k] := 'PLOTSYMx';
  rnam[k] := 'VQRMBx';
  snam[k] := 'VQSMBx';
  ch := chr(k+ord('0'));
  rnam[k][6] := ch;
  snam[k][6] := ch;
  proc_nam[k][8] := ch;
  rchan[k] := 0;
  schan[k] := 0;
  END;
OPEN(LOGFILE, errlog, NEW);
rewrite(LOGFILE);
END;

{/******************************************************\
 |                                                      |
 |                   WAIT_HALF_MINUTE                   |
 |                                                      |
 \******************************************************/}

  PROCEDURE wait_half_minute;
  VAR
    st1,st2:INTEGER;

    FUNCTION sys$schdwk(%IMMED pid,prc:INTEGER;
  		        daytim:quadword;
  		        %IMMED rep:INTEGER):INTEGER;EXTERN;

  BEGIN
  debug('W-H-MO');
  st1 := sys$schdwk(0,0,half_min,0);
  st2 := sys$hiber;
  END;

{/******************************************************\
 |                                                      |
 |                      KILL_PLOT                       |
 |                                                      |
 \******************************************************/}

PROCEDURE kill_plot( qid:INTEGER );

VAR

  id,stat:INTEGER;
  st1,st2,st3,st4:INTEGER;

BEGIN
debug('Killpl');

id := p^.qhead[qid].sub_proc;
IF id <> 0 THEN
  BEGIN
  stat := sys$delprc(id, 0);
  p^.qhead[qid].sub_proc := 0;
  active_pid[qid] := 0;
  st1 := sys$delmbx(rchan[qid]);
  st2 := sys$delmbx(schan[qid]);
  st3 := sys$dassgn(rchan[qid]);
  st4 := sys$dassgn(schan[qid]);
  WITH p^.qhead[qid] DO
    status := status - [plotting] + [waiting]; 
  wait_half_minute;
  END;
END;

{/******************************************************\
 |                                                      |
 |                      ZAP_FILE                        |
 |                                                      |
 \******************************************************/}

PROCEDURE zap_file(a:fdtype);
BEGIN
END;

{/******************************************************\
 |                                                      |
 |                    REMOVE_ENTRY                      |
 |                                                      |
 \******************************************************/}

PROCEDURE remove_entry(qid, jno:INTEGER;VAR ok:BOOLEAN);

LABEL
  99;

VAR

  k,m,nidx,idxt:INTEGER;
  idx:ARRAY [1..3] OF INTEGER;
  found:BOOLEAN;

BEGIN
debug('Rement');
ok := TRUE;
idx[1] := p^.qhead[qid].link1;
IF idx[1] = 0 THEN
  BEGIN
  ok := FALSE;
  GOTO 99;
  END;

IF (jno=0) OR (p^.qinfo[idx[1]].job_head.entry_no = jno) THEN
  	BEGIN
  	p^.qhead[qid].link1 := p^.qinfo[idx[1]].job_head.link;
        idxt := idx[1];
  	WITH p^.qinfo[idx[1]].job_head DO
  	  BEGIN
  	  kill_plot(qid);
  	  working := 0;
  	  END;
  	END
ELSE
  BEGIN
  found := FALSE;
  REPEAT
    idxt := p^.qinfo[idx[1]].job_head.link;
    IF idxt <> 0 THEN
      IF p^.qinfo[idxt].job_head.entry_no = jno THEN found := TRUE
      ELSE idx[1] := idxt;
  UNTIL found OR (idxt = 0);
  IF NOT found THEN
    BEGIN
    ok := FALSE;
    GOTO 99;
    END
  ELSE
    BEGIN
    p^.qinfo[idx[1]].job_head.link := p^.qinfo[idxt].job_head.link;
    idx[1] := idxt;
    END;
  END;

WITH p^.qinfo[idxt].job_head DO
  BEGIN
  idx[2] := vec_link;
  idx[3] := parm_link;
  link := idx[2];
  IF no_delete=0 THEN
    BEGIN
    zap_file(p^.qinfo[idx[2]].file_descr);
    IF idx[3]<>0 THEN
      zap_file(p^.qinfo[idx[3]].file_descr);
    END;
  END;
nidx := 2;
IF idx[3] = 0 THEN
  p^.qinfo[idx[2]].srpls.link := p^.control.flhead
ELSE
  BEGIN
  p^.qinfo[idx[2]].srpls.link := idx[3];
  p^.qinfo[idx[3]].srpls.link := p^.control.flhead;
  nidx := 3;
  END;
p^.control.flhead := idx[1];
FOR m := 1 TO nidx DO
 WITH p^.qinfo[idx[m]].srpls DO
  BEGIN
  FOR k := 1 TO 14 DO fill[k] := 0;
  idtag := '*MT*';
  END;

WITH p^.qhead[qid] DO 
  BEGIN
  entries := entries - 1;
  IF entries = 0 THEN status := status - [waiting] + [idle];
  END;

99:END;			{ remove_entry }

{/******************************************************\
 |                                                      |
 |                      QPLOT_AST                       |
 |                                                      |
 \******************************************************/}

PROCEDURE qplot_ast;
{ This is the guy that handles the software interrupt 
  generated when a user writes to the PLSMBX mailbox.
  The mailbox is primed to generate the interrupt
  in PROCEDURE listen_to_users.

							}
LABEL

  99;

VAR
  c,buf:alfa132;
  iosb:ioblock;
  st0,st1,st2,ST9,nch:INTEGER;
  plot_entry,qid:INTEGER;
  ndev,nf1,nf2:INTEGER;
  pkt1,pkt2,pkt3:INTEGER;
  m,k,lnk1,lnk2,npath:INTEGER;
  ct:quadword;
  tag,userq:alfa4;
  username:alfa12;
  jno:alfa4;
  dev:alfa6;
  ok:BOOLEAN;
  reply:alfa8;
  action:action_type;

  FUNCTION sys$assign( %STDESCR devnam:alfa6; VAR chan:word;
      		%IMMED acmode,mbxnam:INTEGER):INTEGER;EXTERN;

  PROCEDURE cvti4 (k:INTEGER; VAR a:alfa4);
  VAR
    m,n:INTEGER;
  BEGIN
  n := k;
  FOR m := 4 DOWNTO 1 DO
    BEGIN
    a[m] := chr((n MOD 10) + ord('0'));
    n := n DIV 10;
    END;
  END;

  PROCEDURE answer_user;
  
  VAR

    k,st1,st2,st3:INTEGER;
    unit:alfa6;
    b:alfa132;
    repchan:word;
    iosb:ioblock;

  BEGIN
  {
     Prepare a reply to the Requestor.
					}
  FOR k := 1 TO 8 DO b[k] := reply[k];
  unit := 'PRMBxx';
  unit[5] := c[9];
  unit[6] := c[10];
  st1 := sys$assign(unit, repchan, 0, 0);
  st2 := sys$qiow(0, repchan, io$_writevblk+io$m_now,
    	iosb, 0, 0, b, 8, 0, 0, 0, 0);
  st1 := sys$dassgn(repchan);
  END;

BEGIN
debug('QP-ast');
st1 := sys$setast(disable);
st2 := sys$qiow(0, pschan, io$_readvblk, iosb, 
  	0, 0, c, 132, 0, 0, 0, 0);
nch := iosb.byte_count;
FOR k := 1 TO 10 DO WRITE(LOGFILE, c[k]); WRITELN(LOGFILE);
FOR k := 1 TO 4 DO tag[k] := c[k];
FOR k := 1 TO 4 DO userq[k] := c[k+4];
  qid := 0;
  WITH p^.control DO
   FOR k := 1 TO maxq DO
    IF userq = qname[k] THEN qid := k;

IF tag = 'PLOT' THEN action := plot
ELSE IF tag = 'PDEL' THEN action := delete
ELSE IF tag = 'INIQ' THEN action := initq
ELSE IF tag = 'DELQ' THEN action := delq
ELSE IF tag = 'STRT' THEN action := startq
ELSE IF tag = 'STOP' THEN action := stopq
ELSE IF tag = 'KILL' THEN action := abortq
ELSE action := nogood;

IF (action <> initq) AND (qid = 0) THEN
  BEGIN
  reply := 'NO SCH Q';
  answer_user;
  GOTO 99;
  END;

IF (tag = 'PLOT') OR (tag = 'PDEL') THEN
  FOR k := 1 TO 12 DO username[k] := c[k+12];

CASE action OF

  plot:
    BEGIN
    ndev := ord(c[33]);
    nf1  := ord(c[34]);
    nf2  := ord(c[35]);
{
  	Now enter it in the data base.
    Extract three packets from the free list.
    						}
    pkt1 := p^.control.flhead;
    pkt2 := p^.qinfo[pkt1].job_head.link;
    pkt3 := p^.qinfo[pkt2].job_head.link;
    p^.control.flhead := p^.qinfo[pkt3].job_head.link;
{
    Build the Job Header.
    				}
    WITH p^.qinfo[pkt1].job_head DO
      BEGIN
      link := 0;
      user_name := username;
      st1 := sys$gettim(ct);
      entry_time := ct;
      hold_flag := 0;
      IF c[11] = 'N' THEN no_delete := 1
      		     ELSE no_delete := 0;
      IF c[12] = 'N' THEN notify := 1
      		     ELSE notify := 0;
      priority  := 4;
      parm_link := pkt2;
      vec_link  := pkt3;
      job_no := job_no + 1;
      IF job_no > 9999 THEN job_no := 1001;
      p^.control.last_jobno := job_no;
      entry_no := job_no;
      FOR k := 1 TO 4 DO equic.alpha[k] := c[k+24];
      uic := equic.numb;
      idtag := '*JH*';
      END;
{
    Fill in the File Descriptors.
					}
    WITH p^.qinfo[pkt2].file_descr DO
      BEGIN
      link := 0;
      device := userq;
      dlen := ndev;
      flen := nf1;
      dir_name := '                                 ';
      FOR k := 1 TO dlen DO dir_name[k] := c[k+35];
      f_name := '                 ';
      FOR k := 1 TO flen DO f_name[k] := c[k+71];
      idtag := '*FD*';
      END;
    WITH p^.qinfo[pkt3].file_descr DO
      BEGIN
      link := 0;
      device := userq;
      dlen := ndev;
      flen := nf2;
      dir_name := p^.qinfo[pkt2].file_descr.dir_name;
      f_name := '                 ';
      FOR k := 1 TO flen DO f_name[k] := c[k+89];
      idtag := '*FD*';
      END;
{
    Now link the JH to the QH.
				}
    npath := 1;
    IF p^.qhead[qid].link1 = 0 THEN
      p^.qhead[qid].link1 := pkt1
    ELSE
      BEGIN
      lnk2 := p^.qhead[qid].link1;
      REPEAT
        lnk1 := lnk2;
        npath := npath + 1;
        lnk2 := p^.qinfo[lnk1].job_head.link;
      UNTIL lnk2 = 0;
      p^.qinfo[lnk1].job_head.link := pkt1;
      END;
    WITH p^.qhead[qid] DO
      BEGIN
      entries := entries + 1;
      IF entries <> npath THEN vqabort := TRUE;
      IF idle IN status THEN
        status := (status + [waiting]) - [idle];
      END;
{
    Reply...
				}
    cvti4 (job_no, jno);
    reply := 'NEW     ';
    FOR k := 1 TO 4 DO reply[k+4] := jno[k];
    answer_user;
    WRITELN(LOGFILE, ' Queued #', jno);
    END;     { CASE plot }

  initq:
    BEGIN
    IF (qid>0) OR (p^.control.nques>=maxq) THEN
      BEGIN
      IF qid > 0 THEN reply := 'Q EXISTS'
      ELSE 	      reply := 'NO ROOM.';
      answer_user;
      END
    ELSE
      BEGIN
      WITH p^.control DO
	BEGIN
	m := 1;
	WHILE flen[m] <> 0 DO m := m + 1;
	flen[m] := 4;
	qname[m] := userq;
	nques := nques + 1;
	END;
      WITH p^.qhead[m] DO
	BEGIN
	FOR k := 1 TO 4 DO device_name[k] := c[k+12];
	lqname := '            ';
	k := 0;
	WHILE (k<=13) AND (c[k+17]<>' ') DO
	  BEGIN
	  k := k + 1;
	  lqname[k] := c[k+16];
	  END;
	lnlen := k;
	link1 := 0;
	characteristics := [];
	status := [idle, stopped];
	IF c[30] = 'Y' THEN
	  BEGIN
	  status := status + [print_mode];
	  characteristics := characteristics + [printer_attached];
	  END
	ELSE
	  BEGIN
	  characteristics := [no_printer];
	  dev := '_xxxx:';
	  FOR k := 1 TO 4 DO dev[k+1] := userq[k];
	  st0 := sys$alloc(dev, 0, 0, 0);
	  END;
	END;		{ WITH p^.qhead[m] }
      reply := '**DONE**';
      answer_user;
      END;	{ ELSE of IF (qid>0) OR... }
    END;     { CASE initq  }

  startq:
    BEGIN
    IF qid > 0 THEN
     WITH p^.qhead[qid] DO
      status := status - [stopped];
    IF qid > 0 THEN reply := '**DONE**'
    	       ELSE reply := '**NO Q**';
    answer_user;
    END;

  stopq:
    BEGIN
    IF qid > 0 THEN
     WITH  p^.qhead[qid] DO
      status := status + [stopped];
    IF qid > 0 THEN reply := '**DONE**'
    	       ELSE reply := '**NO Q**';
    answer_user;
    END;

  delete:
    BEGIN
    FOR k := 1 TO 4 DO jno[k] := c[k+32];
    plot_entry := 0;
    FOR k := 1 TO 4 DO
      plot_entry := 10*plot_entry + ord(jno[k]) - ord('0');
    remove_entry ( qid, plot_entry, ok );
    IF ok THEN reply := ' Xd     '
    	  ELSE reply := ' NG     ';
    FOR k := 1 TO 4 DO reply[k+4] := jno[k];
    IF ok THEN WRITELN(LOGFILE, ' Deleted #', jno);
    answer_user;
    END;         { CASE delete }

  delq:
    BEGIN
    ok := FALSE;
    IF qid > 0 THEN
     WITH p^.qhead[qid] DO
      BEGIN
      IF stopped IN status THEN
	BEGIN
	WHILE entries > 0 DO remove_entry(qid, 0, ok);
	IF NOT (printer_attached IN characteristics) THEN
	  BEGIN
	  dev := '_xxxx:';
	  FOR k := 1 TO 4 DO dev[k+1] := device_name[k];
	  st0 := sys$dalloc(dev,0);
	  END;
	link := 0;
	link1 := 0;
	device_name := '    ';
	status := [];
	entries := 0;
	characteristics := [];
	lnlen := 0;
	lqname := '            ';
        sub_proc := 0;
	FOR k := 1 TO 7 DO rest[k] := 0;
	idtag := '*QH*';
	reply := '**DONE**';
	ok := TRUE;
	END
      ELSE
	reply := 'NOT*STOP';
      answer_user;
      END;
    IF ok THEN
     WITH p^.control DO
      BEGIN
      nques := nques - 1;
      flen[qid] := 0;
      qname[qid] := '    ';
      END;
    END;

  nogood:
    BEGIN
    WRITELN(LOGFILE, ' Tag not recognized:');
    WRITELN(LOGFILE, ' ***', tag);
    reply := 'Garbage.';
    answer_user;
    END;    { CASE nogood  }

END;      { All CASE declarations }
99:
st9 := 0;
st1 := sys$setast(enable);
st2 := sys$wake(0,0);
listen_to_users;
END;

{/******************************************************\
 |                                                      |
 |                       PLOT_FIN                       |
 |                                                      |
 \******************************************************/}

PROCEDURE plot_fin1;
{
  	This handles the attention AST from VQRMBx,
  	which is written into by the plot driver
  	when it finishes plotting.
  							}

VAR

  ok:BOOLEAN;
  stat,st1,st2,st3,st4:INTEGER;
  nch:INTEGER;
  c:alfa132;
  iosb:ioblock;
  index,qid:INTEGER;

BEGIN
index := 1;
debug('pl-f-1');
st1 := sys$setast(disable);
st2 := sys$qiow(0, rchan[index], io$_readvblk, iosb,
  		0, 0, c, 132, 0, 0, 0, 0);
nch := iosb.byte_count;
qid := index;
WRITELN(LOGFILE,  ' Reply from RASMX; length was ', nch:4);
WRITE(LOGFILE, '  >');
FOR st3 := 1 TO nch DO WRITE(LOGFILE, c[st3]);
WRITELN(LOGFILE);
{				   }
IF iosb.process_id = active_pid[index] THEN
 BEGIN
 WITH p^.qhead[qid] DO
  BEGIN
  p^.qinfo[link1].job_head.working := 0;  
  status := status - [plotting];
  remove_entry(qid, 0, ok);
  IF entries > 0 THEN status := status + [waiting]
  		 ELSE status := status + [idle];
  END;
 END;
st3 := sys$setast(enable);
st4 := sys$wake(0,0);
END;

PROCEDURE plot_fin2;

VAR

  ok:BOOLEAN;
  stat,st1,st2,st3,st4:INTEGER;
  nch:INTEGER;
  c:alfa132;
  iosb:ioblock;
  index,qid:INTEGER;

BEGIN
index := 2;
debug('pl-f-2');
st1 := sys$setast(disable);
st2 := sys$qiow(0, rchan[index], io$_readvblk, iosb,
  		0, 0, c, 132, 0, 0, 0, 0);
nch := iosb.byte_count;
qid := index;
WRITELN(LOGFILE,  ' Reply from RASMX; length was ', nch:4);
WRITE(LOGFILE, '  >');
FOR st3 := 1 TO nch DO WRITE(LOGFILE, c[st3]);
WRITELN(LOGFILE);
{				   }
IF iosb.process_id = active_pid[index] THEN
 BEGIN
 WITH p^.qhead[qid] DO
  BEGIN
  p^.qinfo[link1].job_head.working := 0; 
  status := status - [plotting];
  remove_entry(qid, 0, ok);
  IF entries > 0 THEN status := status + [waiting]
  		 ELSE status := status + [idle];
  END;
 END;
st3 := sys$setast(enable);
st4 := sys$wake(0,0);
END;

{/******************************************************\
 |                                                      |
 |                      MAP_PLOTQ                       |
 |                                                      |
 \******************************************************/}

PROCEDURE map_plotq(VAR p:secptr);

VAR
  inadr,retadr:dbl;
  gsdnam:alfa9;
  mask,channel:longword;
  status:longword;
  protection_mask:word;
  newfile,ok:BOOLEAN;
  newsec,secok:BOOLEAN;

{/******************************************************\
 |                                                      |
 |                      RESET_PSEC                      |
 |                                                      |
 \******************************************************/}

PROCEDURE reset_psec(p:secptr);

VAR
  k,lnk:INTEGER;

BEGIN
FOR k := 1 TO maxq DO
 IF p^.control.flen[k] > 0 THEN
  BEGIN
  WITH p^.qhead[k] DO
    BEGIN
    lnk := link1;
    IF plotting IN status THEN 
  	    status := status - [plotting] + [waiting];
    status := status + [stopped];
    END;
  IF lnk <> 0 THEN p^.qinfo[lnk].job_head.working := 0;
  END;
END;

{/******************************************************\
 |                                                      |
 |                     REBUILD_PSEC                     |
 |                                                      |
 \******************************************************/}
PROCEDURE rebuild_psec(p:secptr);

VAR
  k,m:INTEGER;

BEGIN
job_no := 1000;
WITH p^.control DO
  BEGIN
  flhead := 1;
  nques := 0;
  FOR k := 1 TO 7 DO
    BEGIN
    flen[k] := 0;
    qname[k] := '    ';
    END;
  last_jobno := 1000;
  FOR k := 1 TO 4 DO pad4l[k] := 0;
  idtag := '*CX*';
  END;

FOR m := 1 TO 7 DO
 WITH p^.qhead[m] DO
  BEGIN
  link := 0;
  device_name := '    ';
  link1 := 0;
  status := [];
  entries := 0;
  characteristics := [];
  lnlen := 0;
  lqname := '            ';
  sub_proc := 0;
  FOR k := 1 TO 7 DO rest[k] := 0;
  idtag := '*QH*';
  END;

FOR m := 1 TO 152 DO
 WITH p^.qinfo[m].srpls DO
  BEGIN
  link := m + 1;
  FOR k := 1 TO 14 DO fill[k] := 0;
  idtag := '*MT*';
  END;
END;

BEGIN
gsdnam := 'PLOTQSECT';
mask :=   sec$m_gbl
	+ sec$m_perm
	+ sec$m_sysgbl
	+ sec$m_wrt;
protection_mask := %X2200;

newfile := FALSE;
ok      := TRUE;
secok   := TRUE;
newsec  := FALSE;

status := 0;
useropen(channel, status);
IF status = ss$_created THEN newfile := TRUE
ELSE IF status <> ss$_normal THEN ok := FALSE;

addr1 (inadr);
IF ok THEN
  BEGIN
  status := sys$crmpsc(inadr, retadr, 0, mask, gsdnam,
			0, 0, channel, 20, 0,
			protection_mask, 0);
  IF status = ss$_created THEN newsec := TRUE
  ELSE IF status <> ss$_normal THEN secok := FALSE;
  END

ELSE

  BEGIN
  status := sys$mgblsc(inadr, retadr, 0, 
			sec$m_sysgbl + sec$m_wrt,
			gsdnam, 0, 0);
  IF status <> ss$_normal THEN secok := FALSE;
  END;

IF secok THEN p := retadr.pq1
	 ELSE p := NIL;

IF secok THEN
  IF newfile THEN rebuild_psec(p)
  	     ELSE reset_psec(p);

job_no := p^.control.last_jobno;

END;

{/******************************************************\
 |                                                      |
 |                      MAP_SYSQUE                      |
 |                                                      |
 \******************************************************/}
PROCEDURE map_sysque (VAR q:jbcptr);

VAR
  gsdnam:alfa9;
  status:INTEGER;
  inadr,retadr:dbl;
BEGIN
gsdnam := 'JBCSYSQUE';
addr2(inadr);

status := sys$mgblsc(inadr, retadr, 0,
			sec$m_sysgbl,
			gsdnam, 0, 0);

IF status <> ss$_normal THEN
  BEGIN
  WRITELN(LOGFILE, ' Error mapping JBCSYSQUE..');
  WRITELN(LOGFILE, ' Status was ', status:8);
  halt;
  END;

q := retadr.pj1;
END;

{/******************************************************\
 |                                                      |
 |                   CREATE_MAILBOXES                   |
 |                                                      |
 \******************************************************/}

PROCEDURE create_mailboxes;

VAR
     stat,i:INTEGER;

BEGIN
stat := sys$crembx(1, pschan, 132, 0,0,0, 'PLSMBX');
IF stat <> ss$_normal THEN
  			BEGIN
			WRITELN(LOGFILE, ' MBX CREATE NO GOOD.');
			WRITELN(LOGFILE, ' Status was ', stat:8);
			halt;
		        END;
END;

{/******************************************************\
 |                                                      |
 |                    LISTEN_TO_USERS                   |
 |                                                      |
 \******************************************************/}

PROCEDURE listen_to_users;
VAR
  iosb:ioblock;
  stat:INTEGER;

BEGIN
debug('listen');
stat := sys$qio(0, pschan, io$_setmode+io$m_wrtattn,
		  iosb, 0, 0, qplot_ast, 0, 0, 0, 0, 0);
WRITELN(LOGFILE, ' SET AST stat is ', stat:8);
END;

{/******************************************************\
 |                                                      |
 |                    SWITCH_TO_PLOT                    |
 |                                                      |
 \******************************************************/}

PROCEDURE switch_to_plot(index:INTEGER);

VAR
  st,k,n:INTEGER;
  a:alfa4;
  dev:alfa6;

  PROCEDURE rundown_print(ix:INTEGER);
  
  VAR
    k,nq,waits,n:INTEGER;
    name:alfa4;
    tname:alfa15;
    found,ready,abort:BOOLEAN;

  BEGIN
  name := p^.qhead[ix].device_name;
  tname := '               ';
  FOR k := 1 TO 4 DO tname[k] := name[k];
  nq := q^.numque;
  found := FALSE;
  k := 0;
  WHILE ( k < nq ) AND ( NOT found ) DO
    BEGIN
    k := k + 1;
    WITH q^.queue_descriptor[k] DO
      BEGIN
      found := TRUE;
      FOR n := 1 TO qnlen DO
        IF tname[n] <> qname[n] THEN found := FALSE;
      END;
    END;
  waits := 0;
  abort := FALSE;
  ready := FALSE;
  
  IF found THEN
   WITH q^.queue_descriptor[k] DO
    WHILE NOT ready DO
      IF current = 0 THEN ready := TRUE
      ELSE
	BEGIN
	waits := waits + 1;
	wait_half_minute;
	IF waits > 60 THEN abort := TRUE;
	END;
  END;

BEGIN
debug('sw-plt');
a := p^.qhead[index].device_name;
FOR k := 1 TO 4 DO
  BEGIN
  cmd1[k+24] := a[k];
  cmd2[k+24] := a[k];
  END;

st := LIB$EXECUTE_CLI( cmd0, cmd1, cmd5 );

WITH p^.qhead[index] DO status := status - [print_mode];
rundown_print(index);

st := LIB$EXECUTE_CLI( cmd0, cmd2, cmd5 );

dev := '_xxxx:';
FOR k := 1 TO 4 DO dev[k+1] := p^.qhead[index].device_name[k];
st := sys$alloc(dev,0,0,0);

END;

{/******************************************************\
 |                                                      |
 |                      START_PLOT                      |
 |                                                      |
 \******************************************************/}

PROCEDURE start_plot(index:INTEGER);

LABEL 97;

VAR
  
  pidx,vidx,pid,m,k:INTEGER;
  iosba,iosbb,iosbc,iosb2:ioblock;
  st0,st1,st2,st3,st4,st5,st6:INTEGER;
  st01,st02,st03:INTEGER;
  st9,nc:INTEGER;
  fn:alfa132;
  dev:alfa6;

FUNCTION sys$creprc  (VAR pid:longword;
  			%STDESCR image:alfa16;
  			%STDESCR input,output,error:alfa6;
  			%IMMED prvadr,quota:INTEGER;
  			%STDESCR prcnam:alfa8;
  			%IMMED prio,uic,mbx,sts:INTEGER):INTEGER;EXTERN;

  FUNCTION put_name( a:fdtype ):INTEGER;
  VAR
    k:INTEGER;
  BEGIN
  fn := blanks;
  WITH a DO
    BEGIN
    FOR k := 1 TO dlen DO fn[k] := dir_name[k];
    FOR k := 1 TO flen DO fn[dlen+k] := f_name[k];
    put_name := flen + dlen;
    END;
  END;

BEGIN
debug('st-plt');
st0 := sys$setast(disable);

IF p^.qhead[index].entries = 0 THEN GOTO 97;

st01 := sys$crembx(0, schan[index], 132, 0, 0, 0, snam[index]);
st02 := sys$crembx(0, rchan[index], 132, 0, 0, 0, rnam[index]);

REPEAT
st03 := sys$creprc( pid, 'SYS$SYSTEM:RASMX',
  		   snam[index], rnam[index], rnam[index],
  		   0, 0, proc_nam[index], 4, 0, 0, 0);
wait_half_minute;
UNTIL st03 <> ss$_duplnam;

active_pid[index] := pid;

WITH p^.qhead[index] DO
  BEGIN
  sub_proc := pid;
  status := status - [waiting] + [plotting];
  m := link1;
  END;

WITH p^.qinfo[m].job_head DO
  BEGIN
  working := 1;
  pidx := parm_link;
  vidx := vec_link;
  END;

nc := put_name(p^.qinfo[pidx].file_descr);
WRITE(LOGFILE, ' PARM: ');
FOR k := 1 TO nc DO WRITE(LOGFILE, fn[k]);
WRITELN(LOGFILE);

st2 := sys$qiow(0, schan[index], io$_writevblk+io$m_now,
  		iosba, 0, 0, fn, nc, 0, 0, 0, 0);

nc := put_name(p^.qinfo[vidx].file_descr);
WRITE(LOGFILE, ' VECT: ');
FOR k := 1 TO nc DO WRITE(LOGFILE, fn[k]);
WRITELN(LOGFILE);

st3 := sys$qiow(0, schan[index], io$_writevblk+io$m_now,
  		iosbb, 0, 0, fn, nc, 0, 0, 0, 0);

dev := '_xxxx:';
FOR k := 1 TO 4 DO dev[k+1] := p^.qhead[index].device_name[k];
FOR k := 1 TO 6 DO fn[k] := dev[k];
st6 := sys$qiow(0, schan[index], io$_writevblk+io$m_now,
  		iosbc, 0, 0, fn, 6, 0, 0, 0, 0);

CASE index OF
  1:st4 := sys$qio(0, rchan[index], io$_setmode+io$m_wrtattn,
  		iosb2, 0, 0, plot_fin1, 0, 0, 0, 0, 0);
  2:st4 := sys$qio(0, rchan[index], io$_setmode+io$m_wrtattn,
  		iosb2, 0, 0, plot_fin2, 0, 0, 0, 0, 0)
END;
97:
{
  	Debug Output...
  				}
WRITELN(LOGFILE, ' In START_PLOT. st9 was ', st9:4 );
WRITE(LOGFILE, ' st2-st4 were: ');
WRITELN(LOGFILE, st2:4, ' ', st3:4, ' ', st4:4);
WRITELN(LOGFILE, ' st01-03 were ', st01:4, ' ', st02:4, ' ', st03:4);
{
  	End Debug Output.
  				}
st5 := sys$setast(enable);
END;

{/******************************************************\
 |                                                      |
 |                    SWITCH_TO_PRINT                   |
 |                                                      |
 \******************************************************/}

PROCEDURE switch_to_print(index:INTEGER);
VAR
  st0,st1,k:INTEGER;
          a:alfa4;
  	dev:alfa6;

BEGIN
debug('sw-prt');
dev := '_xxxx:';
a := p^.qhead[index].device_name;
FOR k := 1 TO 4 DO
  BEGIN
  cmd3[k+19] := a[k];
  cmd3[k+24] := a[k];
  cmd4[k+24] := a[k];
  dev[k+1] := a[k];
  END;

st0 := sys$dalloc(dev,0);

st1 := LIB$EXECUTE_CLI(cmd3, cmd4, cmd5);

WITH p^.qhead[index] DO status := status + [print_mode];

END;

{/******************************************************\
 |                                                      |
 |                         SLEEP                        |
 |                                                      |
 \******************************************************/}

PROCEDURE sleep;
VAR
  st:INTEGER;
BEGIN
st := sys$hiber;
END;

{/******************************************************\
 |                                                      |
 |                        DISPLAY                       |
 |                                                      |
 \******************************************************/}

PROCEDURE show_section;

VAR

  m,k:INTEGER;

BEGIN
WITH p^.control DO
  BEGIN
  WRITELN(LOGFILE, ' There are ', nques:1, ' queues:');
  FOR k := 1 TO maxq DO
   IF flen[k] <> 0 THEN
    BEGIN
    WRITE(LOGFILE, '    ');
    FOR m := 1 TO flen[k] DO WRITE(LOGFILE, qname[k][m]);
    WRITELN(LOGFILE);
    END;
  WRITELN(LOGFILE, ' Last job # was ', last_jobno:4);
  WRITELN(LOGFILE);
  END;
FOR m := 1 TO maxq DO
IF p^.control.flen[m] > 0 THEN
 WITH p^.qhead[m] DO
  BEGIN
  WRITELN(LOGFILE);
  WRITELN(LOGFILE,  ' Q # ', m:2);
  WRITELN(LOGFILE);
  WRITE(LOGFILE, ' Link= ',link:3,', Link1= ', link1:3);
  WRITELN(LOGFILE);
  WRITELN(LOGFILE, ' ', entries:3, ' entries.');
  WRITE(LOGFILE, ' Status: ');
  IF idle IN status THEN WRITE(LOGFILE, 'idle ');
  IF waiting IN status THEN WRITE(LOGFILE, 'waiting ');
  IF plotting IN status THEN WRITE(LOGFILE, 'plotting ');
  IF stopped IN status THEN WRITE(LOGFILE, 'stopped ');
  IF print_mode IN status THEN WRITE(LOGFILE, 'print_mode ');
  WRITELN(LOGFILE);
  FOR k := 1 TO lnlen DO WRITE(LOGFILE, lqname[k]);
  WRITELN(LOGFILE);
  END;
END;

{/******************************************************\
 |                                                      |
 |                         MAIN                         |
 |                                                      |
 \******************************************************/}

BEGIN
initialize_vq;
map_plotq(p);
map_sysque(q);
create_mailboxes;
listen_to_users;
WHILE NOT vqabort DO
  BEGIN
  FOR idx := 1 TO maxq DO
   WITH p^.qhead[idx] DO
    IF status <> [] THEN
    BEGIN
    IF (NOT (stopped IN status)) AND (waiting IN status) THEN
      BEGIN
      IF print_mode IN status THEN switch_to_plot(idx);
      start_plot(idx);
      END;
    IF (printer_attached IN characteristics) AND
       (status*[stopped,idle,print_mode]=[idle]) THEN
         switch_to_print(idx);
    END;
  sleep;
  END;
IF vqabort THEN WRITELN(LOGFILE, ' VQ aborted.');
END.
